Package: ASSET
Title: An R package for subset-based association analysis of
        heterogeneous traits and subtypes
Version: 2.28.0
Date: 2021-09-04
Authors@R: c(
	person("Samsiddhi", "Bhattacharjee", role = c("aut", "cre"), email="sb1@nibmg.ac.in"),
	person("Guanghao", "Qi", role = "aut"),
	person("Nilanjan", "Chatterjee", role = "aut"),
	person("William", "Wheeler", role = "aut")
	)
Description: An R package for subset-based analysis of heterogeneous traits and disease subtypes. 
	The package allows the user to search through all possible subsets of z-scores to 
	identify the subset of traits giving the best meta-analyzed z-score. Further, it returns a p-value
	adjusting for the multiple-testing involved in the search. It also allows for searching for the 
	best combination of disease subtypes associated with each variant.
Depends: R (>= 3.5.0), stats, graphics
Imports: MASS, msm, rmeta
Suggests: RUnit, BiocGenerics, knitr
VignetteBuilder: knitr
License: GPL-2 + file LICENSE
biocViews: StatisticalMethod, SNP, GenomeWideAssociation,
        MultipleComparison
RoxygenNote: 7.1.2
git_url: https://git.bioconductor.org/packages/ASSET
git_branch: RELEASE_3_22
git_last_commit: 7481559
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 02:33:15 UTC; biocbuild
Author: Samsiddhi Bhattacharjee [aut, cre],
  Guanghao Qi [aut],
  Nilanjan Chatterjee [aut],
  William Wheeler [aut]
Maintainer: Samsiddhi Bhattacharjee <sb1@nibmg.ac.in>

h.traits <- function(snp.vars, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor=NULL
	, cor.numr=FALSE, search=NULL, side=2, meta=FALSE, zmax.args=NULL
	, meth.pval="DLM", pval.args=NULL)
{
    if (!is.null(search)) {
      if (!(search %in% c(1, 2))) stop("search must be NULL, 1 or 2")
    }
    if ((is.null(side)) || (!(side %in% c(1, 2)))) stop("side must be 1 or 2")
    if ((is.null(meth.pval)) || (!(meth.pval %in% c("DLM", "IS", "B")))) stop("meth.pval must be DLM, IS, or B")
    if ((is.null(meta)) || (!(meta %in% 0:1))) stop("meta must be TRUE or FALSE")
    if ((is.null(cor.numr)) || (!(cor.numr %in% 0:1))) stop("cor.numr must be TRUE or FALSE")
    if (!is.null(pval.args)) {
      if (!is.list(pval.args)) stop("pval.args must be a named list")
      temp <- names(pval.args)
      if (is.null(temp)) stop("pval.args must be a named list")
    }
    if (!is.null(zmax.args)) {
      if (!is.list(zmax.args)) stop("zmax.args must be a named list")
      temp <- names(zmax.args)
      if (is.null(temp)) stop("zmax.args must be a named list")
    }

	k         <- length(traits.lab)
	meth.pval <- meth.pval[1]
	nsnp      <- length(snp.vars)
	beta.hat  <- matrix(beta.hat, ncol=k, byrow=FALSE)
	sigma.hat <- matrix(sigma.hat, ncol=k, byrow=FALSE)
	
       #SB: traits.forest calling for 1 snp with whole matrix. So this was generating error.
       #if(nrow(beta.hat) > nsnp) stop("nrow(beta.hat) must equal length(snp.vars)")	
       #if(nrow(sigma.hat) > nsnp) stop("nrow(sigma.hat) must equal length(snp.vars)")

	if(nrow(beta.hat) > nsnp) beta.hat <- matrix(beta.hat[snp.vars, drop=FALSE], nrow = nsnp, ncol=k, byrow=FALSE)
	if(nrow(sigma.hat) > nsnp) sigma.hat <- matrix(sigma.hat[snp.vars, drop=FALSE], nrow = nsnp, ncol=k, byrow=FALSE)

	rownames(beta.hat) <- snp.vars
	rownames(sigma.hat) <- snp.vars
	colnames(beta.hat) <- traits.lab
	colnames(sigma.hat) <- traits.lab
	
	if(!((length(ncase) == k) && is.null(dim(ncase))) && !(is.matrix(ncase) && (ncol(ncase) == k) && (nrow(ncase) == nsnp)))
		stop("ncase should be a vector of size k or a matrix of dimension nsnp X k")
	if(is.null(dim(ncase))) dim(ncase) <- c(1, k)
	if(!((length(ncntl) == k) && is.null(dim(ncntl))) && !(is.matrix(ncntl) && (ncol(ncntl) == k) && (nrow(ncntl) == nsnp)))
		stop("ncntl should be a vector of size k or a matrix of dimension nsnp X k")
	if(is.null(dim(ncntl))) dim(ncntl) <- c(1, k)

	if(is.null(cor)) cor <- diag(k)
	if(!is.matrix(cor) && !is.list(cor)) stop("cor should be a matrix or a list")
	if(is.list(cor))
	{
		#if(!all(c("N11", "N00", "N10", "N01") %in% names(cor)))
	    #		stop("Expected four matrices in list cor with names N11, N00, N10 and N01")
		#if(!all(vapply(cor[c("N11", "N00", "N10", "N01")]
			#, function(m) { is.matrix(m) && nrow(m) == k  && ncol(m) == k }, TRUE)))
	    # 		stop("N11, N00, N10 and N01 should be square matrices of dimension k")

       # Changed Aug 08 2013
       if(!all(c("N11", "N00", "N10") %in% names(cor))) {
	     stop("Expected three matrices in list cor with names N11, N00 and N10")
       }
	   if(!all(vapply(cor[c("N11", "N00", "N10")]
		, function(m) { is.matrix(m) && nrow(m) == k  && ncol(m) == k }, TRUE)))
	     		stop("N11, N00 and N10 should be square matrices of dimension k")
       cor$N01 <- t(cor$N10)

	   cor <- corr.mat.logit(cor$N11, cor$N00, cor$N10, cor$N01)
	}

	if(!is.null(colnames(cor)) && any(colnames(cor) != traits.lab)) stop("cor should have column names in same order as traits.lab")
	if(!is.null(rownames(cor)) && any(rownames(cor) != traits.lab)) stop("cor should have row names in same order as traits.lab")
	
	
	pval <- pval1 <- pval2 <- rep(NA, nsnp)
	names(pval) <- names(pval1) <- names(pval2) <- snp.vars

	beta <- beta1 <- beta2 <- rep(NA, nsnp)
	names(beta) <- names(beta1) <- names(beta2) <- snp.vars

	sd <- sd1 <- sd2 <- rep(NA, nsnp)
	names(sd) <- names(sd1) <- names(sd2) <- snp.vars
	
	pheno <- pheno1 <- pheno2 <- matrix(FALSE, nsnp, k)
	colnames(pheno) <- colnames(pheno1) <- colnames(pheno2) <- traits.lab
	rownames(pheno) <- rownames(pheno1) <- rownames(pheno2) <- snp.vars

    # Vectors for new meta-anlaysis standard errors
	sd.meta <- sd1.meta <- sd2.meta <- rep(NA, nsnp)
	names(sd.meta) <- names(sd1.meta) <- names(sd2.meta) <- snp.vars


	OS <- (is.null(search) || search==1)
	TS <- (is.null(search) || search==2)
	meta.res <- sub1.res <- sub2.res <- NULL
	if(meta)
	{ 
		for(j in seq_len(nsnp))
		{
			jj <- if(nrow(ncase) == 1) 1 else j
			sub <- !(is.na(beta.hat[j, ]) | is.na(sigma.hat[j, ]) | is.na(ncase[jj, ]) | is.na(ncntl[jj, ]))
			if(any(sub))
			{
				nsub <- sum(sub)
				rmat <- matrix(cor[sub, sub], nsub, nsub)
				res <- traits.meta(sub, snp.vars[j], beta.hat[j, ], sigma.hat[j,]
							, ncase[jj, ], ncntl[jj, ], rmat = cor, side = side
							, cor.numr = cor.numr, wt.sigma = TRUE)
				pval[j] <- res$pval
				beta[j] <- res$beta
				sd[j] <- res$sd

            			# Compute new meta-analysis standard error
            			#sd.meta[j] <- meta.se(cor, sigma.hat[j, ])
			}
		}
		meta.res <- list(pval=pval, beta=beta, sd=sd)
	}

	subset0 <- data.frame(pval=rep(NA, nsnp), pheno=rep("NA", nsnp), stringsAsFactors=FALSE)
	subset00 <- data.frame(pval=rep(NA, nsnp), pheno1=rep("NA", nsnp), pheno2=rep("NA", nsnp), 
                           stringsAsFactors=FALSE)

	if(OS)
	{ 	
		if(is.null(pval.args) || is.null(pval.args$search)) pval.args <- c(pval.args, list(search = 1))
		else pval.args$search <- 1

		for(j in seq_len(nsnp))
		{
			jj <- if(nrow(ncase) == 1) 1 else j
			sub <- !(is.na(beta.hat[j, ]) | is.na(sigma.hat[j, ]) | is.na(ncase[jj, ]) | is.na(ncntl[jj, ]))
			if(any(sub))
			{
				nsub <- sum(sub)
				rmat <- matrix(cor[sub, sub], nsub, nsub)
				res <- h.traits1(nsub, beta.hat[j, sub], sigma.hat[j, sub], ncase[jj, sub], ncntl[jj, sub]
							, rmat = rmat, cor.numr=cor.numr, side = side, zmax.args=zmax.args
						 	, meth.pval=meth.pval, pval.args=pval.args)

				pval[j]       <- res$pval
				pheno[j, sub] <- res$pheno
				beta[j]       <- res$beta
				sd[j]         <- res$sd

				# Compute new meta-analysis standard error
				sd.meta[j] <- meta.se(cor, sigma.hat[j, ], subset=res$pheno)

			}
			
		}
		sub1.res <- list(pval=pval, beta=beta, sd=sd, pheno=pheno, sd.meta=sd.meta)
	}

	if(TS)
	{ 
		if(is.null(pval.args) || is.null(pval.args$search)) pval.args <- c(pval.args, list(search = 2))
		else pval.args$search <- 2

		for(j in seq_len(nsnp))
		{
			jj <- if(nrow(ncase) == 1) 1 else j
			res <- NULL
			sub <- !(is.na(beta.hat[j, ]) | is.na(sigma.hat[j, ]) | is.na(ncase[jj, ]) | is.na(ncntl[jj, ]))
			if(any(sub))
			{
				nsub <- sum(sub)
				rmat <- matrix(cor[sub, sub], nsub, nsub)

				res <- h.traits2(nsub, beta.hat[j, sub], sigma.hat[j, sub], ncase[jj, sub], ncntl[jj, sub], 
                                 rmat=rmat, cor.numr=cor.numr, side = side, zmax.args=zmax.args, 
                                 meth.pval=meth.pval, pval.args=pval.args)

                pval[j]        <- res$pval
			    pval1[j]       <- res$pval.1
		     	pval2[j]       <- res$pval.2
			    pheno1[j, sub] <- res$pheno.1
			    pheno2[j, sub] <- res$pheno.2
			    beta1[j]       <- res$beta.1
			    beta2[j]       <- res$beta.2
			    sd1[j]         <- res$sd.1
			    sd2[j]         <- res$sd.2

                # Compute new meta-analysis standard error
                sd1.meta[j] <- meta.se(cor, sigma.hat[j, ], subset=res$pheno.1)
                sd2.meta[j] <- meta.se(cor, sigma.hat[j, ], subset=res$pheno.2)

			}
			
			
		}

		sub2.res <- list(pval=pval, pval.1 = pval1, beta.1=beta1, sd.1=sd1, pheno.1=pheno1,
						 pval.2=pval2, beta.2=beta2, sd.2=sd2, pheno.2=pheno2,
                         sd.1.meta=sd1.meta, sd.2.meta=sd2.meta)
	}

	#ret <- list(Meta=meta.res, Subset.1sided=sub1.res, Subset.2sided=sub2.res)
    ret <- list(Meta=meta.res, Subset.1sided=sub1.res, Subset.2sided=sub2.res,
           snp.vars=snp.vars, traits.lab=traits.lab, beta.hat=beta.hat, sigma.hat=sigma.hat,
           ncase=ncase, ncntl=ncntl, cor=cor, cor.numr=cor.numr, search=search,
           side=side, meta=meta, zmax.args=zmax.args, meth.pval=meth.pval,
           pval.args=pval.args, which="h.traits")
 
	ret
}


h.traits1 <- function(k, beta.hat, sigma.hat, ncase, ncntl, rmat, cor.numr, side=2, zmax.args=NULL, meth.pval="DLM", pval.args=NULL)
{
	if(k == 0) return(list(pval = 1, pheno = NULL, beta = NA, sd = NA, subsetCount=0))
	
##### NOTE: meta.def is set to traits.meta ######
	res <- do.call(z.max, c(list(k, 1, side=side, meta.def=traits.meta, meta.args=list(beta.hat=beta.hat, sigma.hat=sigma.hat
				 , ncase=ncase, ncntl=ncntl, rmat=rmat, cor.numr=cor.numr, wt.sigma=FALSE)), zmax.args))

	zopt <- as.double(res$opt.z)
	pheno <- as.logical(res$opt.s)
	subsetCount <- res$subsetCount
	rm(res)

	if(meth.pval == "DLM")
	{
		if(is.null(pval.args) || !("cor.def" %in% names(pval.args))) pval.args <- c(pval.args, list(cor.def=NULL))
		if(!("cor.args" %in% names(pval.args))) pval.args <- c(pval.args, list(cor.args = list(ncase=ncase, ncntl=ncntl, rmat=rmat, cor.numr=cor.numr)))

		pval <- do.call(p.dlm, c(list(t.vec=abs(zopt), k=k, side = side), pval.args))
	}
	if(meth.pval == "IS")
	{
		pval <- do.call(p.tube, c(list(t.vec=abs(zopt), k=k, side = side, ncase=ncase
								, ncntl=ncntl, rmat=rmat, cor.numr=cor.numr), pval.args))
	}
	if(meth.pval=="B") pval <- p.bon(abs(zopt), subsetCount, search = 1, side = side)
    

	beta <- sd <- NA
		
	res <- traits.meta(pheno, 1, beta.hat, sigma.hat, ncase, ncntl, rmat=rmat, wt.sigma=TRUE)
	
	beta <- res$beta
	if(side == 2) sd <- abs(beta)/qnorm(pval/2, lower.tail=FALSE, log.p = FALSE)
	else sd <- beta/qnorm(pval, lower.tail=FALSE, log.p = FALSE)
	ret <- list(pval = pval, pheno = pheno, beta = beta, sd = sd, subsetCount=subsetCount)
}

h.traits2 <- function(k, beta.hat, sigma.hat, ncase, ncntl, rmat, cor.numr, side=2, zmax.args=NULL, meth.pval="DLM", pval.args=NULL)
{
	sub1 <- which(beta.hat >= 0)
	sub2 <- which(beta.hat < 0)

	k1 <- length(sub1)
	k2 <- length(sub2)

	pval.args1 <- pval.args
	pval.args2 <- pval.args

	if(!is.null(pval.args) && !is.null(pval.args$sizes))
	{
		sizes <- pval.args$sizes
		csizes <- cumsum(sizes)
		csizes0 <- c(0, cumsum(sizes[-length(sizes)]))
		sizes1 <- vapply(seq_along(sizes), function(i) { sum(sub1 > csizes0[i] & sub1 <= csizes[i]) }, 0L)
		sizes2 <- vapply(seq_along(sizes), function(i) { sum(sub2 > csizes0[i] & sub2 <= csizes[i]) }, 0L)
		sizes1 <- sizes1[sizes1 > 0]
		sizes2 <- sizes2[sizes2 > 0]
		pval.args1$sizes <- sizes1
		pval.args2$sizes <- sizes2
	}

	res1 <- h.traits1(k1, beta.hat=beta.hat[sub1], sigma.hat=sigma.hat[sub1], ncase=ncase[sub1]
					  , ncntl=ncntl[sub1], rmat=rmat[sub1, sub1]
					  , cor.numr=cor.numr, side=side, zmax.args=zmax.args
					  , meth.pval=meth.pval, pval.args=pval.args1)

	res2 <- h.traits1(k2, beta.hat=beta.hat[sub2], sigma.hat=sigma.hat[sub2], ncase=ncase[sub2]
					  , ncntl=ncntl[sub2], rmat[sub2, sub2]
					  , cor.numr=cor.numr, side=side, zmax.args=zmax.args
					  , meth.pval=meth.pval, pval.args=pval.args2)

	#zopt <- if ( (!is.finite(res1$pval)) || (!is.finite(res2$pval)) || 
    #             (res1$pval <= 0) || (res2$pval <= 0) ) NA else -2 * (log(res1$pval) + log(res2$pval))		
    zopt <- -2*(log(res1$pval) + log(res2$pval))		

    subsetCount <- res1$subsetCount + res2$subsetCount


	if(k1 > 0 && k2 > 0) 
	{ 
		if(meth.pval != "B") pval <- pchisq(zopt, df = 4, lower.tail = FALSE)
		#if(meth.pval == "B") pval <- pchisq(zopt, df = 4, lower.tail = FALSE) * ((2^k1 - 1) * (2^k2 - 1))
        if(meth.pval == "B") pval <- pchisq(zopt, df = 4, lower.tail = FALSE) * subsetCount
	}
	if(k1 == 0 || k2 == 0 )
	{
		if(meth.pval != "B") pval <- pchisq(zopt, df = 2, lower.tail = FALSE)
		#if(meth.pval == "B") pval <- pchisq(zopt, df = 2, lower.tail = FALSE) * ((2^k - 1))
        if(meth.pval == "B") pval <- pchisq(zopt, df = 2, lower.tail = FALSE) * subsetCount
	}

	pheno1 <- rep(FALSE, k) ; pheno1[sub1] <- res1$pheno
	pheno2 <- rep(FALSE, k) ; pheno2[sub2] <- res2$pheno
	
	ret <- list(pval = pval, pval.1=res1$pval, pval.2=res2$pval, pheno.1 = pheno1, pheno.2 = pheno2
				, beta.1 = res1$beta, sd.1 = res1$sd, beta.2 = res2$beta, sd.2 = res2$sd)
	ret
}	

traits.meta <- function(sub, snp.vars, beta.hat, sigma.hat, ncase, ncntl, rmat, side=2, cor.numr=FALSE, wt.sigma=FALSE)
{	
	k <- length(sub)
	if(is.null(dim(rmat))) dim(rmat) <- c(k, k)
	nsnp <- length(snp.vars)
	if(nsnp > 1) stop("Expected nsnp=1")

	z <- beta <- sd <- pval <- rep(NA, nsnp)
	nsub <- sum(sub)
	
	if(!wt.sigma)
	{
		zvec <- beta.hat[sub]/sigma.hat[sub]
		rneff <- sqrt((ncase[sub] * ncntl[sub])/(ncase[sub] + ncntl[sub]))
		if(cor.numr) rneff <- mySolve(rmat[sub, sub], rneff)
		numr <- sum(zvec * rneff)
		denr <- sum(outer(rneff, rneff) * matrix(rmat[sub, sub], nsub, nsub))

        # Changed July 31, 2013
		#z <- ifelse(is.na(denr) | is.nan(denr) | denr == 0, NA, numr/sqrt(denr))
        z <- ifelse(is.na(denr) | is.nan(denr), NA, numr/sqrt(denr))
	} else
	{
		Sigma <- diag(sigma.hat[sub], nsub) %*% matrix(rmat[sub, sub], nsub, nsub) %*% diag(sigma.hat[sub], nsub)
		if(cor.numr) wt <- mySolve(Sigma, rep(1, nsub))
		else wt <- (1/sigma.hat[sub]^2)
		
		numr  <- sum(beta.hat[sub] * wt)
		denr  <- sum(outer(wt, wt) * matrix(Sigma, nsub, nsub))

#		sumwt <- sum(wt)
#		beta  <- numr/sumwt
		beta <- numr/denr		
#		sd    <- sqrt(denr)/sumwt
		sd <- (1/denr)
        # Changed July 31, 2013
		#z <- ifelse(is.na(denr) | is.nan(denr) | denr == 0, NA, numr/sqrt(denr))
        z <- ifelse(is.na(denr) | is.nan(denr), NA, numr/sqrt(denr))
	}
	if(side == 2) pval <- 2 * pnorm(abs(numr/sqrt(denr)), lower.tail=FALSE)
	else pval <- pnorm(numr/sqrt(denr), lower.tail=FALSE)

	list(z = z, beta = beta, sd = sd, pval = pval)
}

traits.forest0 <- function(snp.var, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor = NULL, rlist = NULL
, level = 0.05, p.adj = TRUE, digits = 2)
{
	if(length(snp.var) > 1) stop("Length of snp.var should be 1")	
	if(!(snp.var %in% rownames(beta.hat))) stop("rownames of beta.hat does not have snp.var")
	k <- length(traits.lab)
	
	if(!is.null(rlist))
	{
		if(is.null(rlist$Meta)) stop("Missing Component in rlist: Meta")
		if(is.null(rlist$Subset.1sided)) stop("Missing Component in rlist: Subset.1sided")
		if(is.null(rlist$Subset.2sided)) stop("Missing Component in rlist: Subset.2sided")
	} else
	{
		rlist <- h.traits(snp.vars = snp.var, traits.lab = traits.lab, beta.hat = beta.hat, sigma.hat = sigma.hat
						  , ncase = ncase, ncntl = ncntl, cor = cor, search = NULL, meta = TRUE)
	}
	
	beta <- beta.hat[snp.var, ]
	sd <- sigma.hat[snp.var, ]
	res <- list(beta = beta, sd = sd, pval = 2 * pnorm(abs(beta/sd), lower.tail=FALSE))
	
	h.forest(k, snp.var, traits.lab, rlist, res, side = 2, level=level, p.adj = p.adj, digits=digits)
}

traits.forest <- function(rlist, snp.var, level=0.05, p.adj=TRUE, digits=2, calc.miss=FALSE)
{
	if(length(snp.var) > 1) stop("Length of snp.var should be 1")
	if(!(snp.var %in% rlist$snp.vars)) stop("snp.var was not a SNP analyzed")
    traits.lab <- rlist$traits.lab
    beta.hat   <- rlist$beta.hat[snp.var, ]
    sigma.hat  <- rlist$sigma.hat[snp.var, ]
    ncase      <- rlist$ncase[1, ]
    ncntl      <- rlist$ncntl[1, ]
    cor        <- rlist$cor
    cor.numr   <- rlist$cor.numr
    search     <- rlist$search
    side       <- rlist$side
    zmax.args  <- rlist$zmax.args
    meth.pval  <- rlist$meth.pval
    pval.args  <- rlist$pval.args 

	k <- length(traits.lab)
	nsub <- matrix(FALSE, k, k)
	diag(nsub) <- TRUE
	
    ov      <- rlist[["Meta", exact=TRUE]]
    cc      <- rlist[["Subset.1sided", exact=TRUE]]
    cp      <- rlist[["Subset.2sided", exact=TRUE]]
    ov.flag <- !is.null(ov)
    cc.flag <- !is.null(cc)
    cp.flag <- !is.null(cp)
    if (calc.miss && ((!ov.flag) || (!cc.flag) || (!cp.flag))) 
    {
	if (ov.flag)
	{
		meta <- FALSE
      	} else 
      	{
      		meta <- TRUE
      	}
      	search <- NULL
      	if ((!cc.flag) && (!cp.flag)) 
      	{
      		search <- NULL
      	} else if (!cc.flag) 
      	{
		search <- 1
	} else if (!cp.flag) 
	{
		search <- 2
	}
    	ret <- h.traits(snp.var, traits.lab, beta.hat, sigma.hat, ncase, ncntl, 
                     cor=cor, cor.numr=cor.numr, search=search, side=side, 
                     meta=meta, zmax.args=zmax.args, meth.pval=meth.pval, 
                     pval.args=pval.args)
	if (!ov.flag) ov <- ret[["Meta", exact=TRUE]]
	if (!cc.flag) cc <- ret[["Subset.1sided", exact=TRUE]]
	if (!cp.flag) cp <- ret[["Subset.2sided", exact=TRUE]]
    }
    
    newlist <- list(Meta=ov, Subset.1sided=cc, Subset.2sided=cp)
    
    beta <- beta.hat
    sd   <- sigma.hat
    res  <- list(beta=beta, sd=sd, pval=2*pnorm(abs(beta/sd), lower.tail=FALSE))
	
    h.forest(k, snp.var, traits.lab, newlist, res, side=2, level=level, 
             p.adj=p.adj, digits=digits)

}

test_h.traits <- function() {

  data(ex_trait, package="ASSET")
  data       <- data[1, , drop=FALSE]
  snps       <- as.vector(data[, "SNP"])
  traits.lab <- paste("Trait_", 1:6, sep="")
  beta.hat   <- as.matrix(data[, paste(traits.lab, ".Beta", sep="")])
  sigma.hat  <- as.matrix(data[, paste(traits.lab, ".SE", sep="")])
  cor        <- list(N11=N11, N00=N00, N10=N10)
  ncase      <- diag(N11)
  ncntl      <- diag(N00)
  res        <- h.traits(snps, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor=cor, 
                 cor.numr=FALSE, search=NULL, side=2, meta=TRUE, 
                 zmax.args=NULL, meth.pval="DLM")
 
  lvec1 <- c(FALSE, TRUE, TRUE, FALSE, FALSE, FALSE)
  lvec2 <- c(TRUE, FALSE, FALSE, FALSE, TRUE, TRUE)
  lvec3 <- c(FALSE, TRUE, TRUE, FALSE, FALSE, FALSE)


  checkEqualsNumeric(res$Meta$pval, 0.26756223, tolerance=1.0e-6)
  checkEqualsNumeric(res$Subset.1sided$pval, 1.877814e-02, tolerance=1.0e-6)
  checkEquals(sum(res$Subset.1sided$pheno == lvec1), 6)
  checkEqualsNumeric(res$Subset.2sided$pval, 1.248431e-03, tolerance=1.0e-6)
  checkEqualsNumeric(res$Subset.2sided$pval.1, 0.0539668, tolerance=1.0e-6)
  checkEqualsNumeric(res$Subset.2sided$pval.2, 0.002316304, tolerance=1.0e-6)
  checkEquals(sum(res$Subset.2sided$pheno.1 == lvec2), 6)
  checkEquals(sum(res$Subset.2sided$pheno.2 == lvec3), 6)
}

p.bon <- function(t.vec, M, search, side)
{
    # M    number of subsets considered

	if(any(t.vec < 0)) warning("Negative input thresholds! Using absolute value.")
	t.vec <- abs(t.vec)
	if(search < 2 & side == 2) pval.b <- pmin(2 * pnorm(t.vec, lower.tail=FALSE) * M, 1)
	if(search < 2 & side == 1) pval.b <- pmin(pnorm(t.vec, lower.tail=FALSE) * M, 1)
	if(search == 2) stop("Seach option 2 not yet implemented")

	pval.b
}

p.tube <- function(t.vec, k, search, side, ncase, ncntl, pool, rmat, cor.numr, sizes=rep(1, k)
	, nsamp=50, sub.def=NULL, sub.args=NULL, wt.def=NULL, wt.args=NULL)
{
	if(!is.null(sub.def) && !is.function(sub.def)) stop("'sub.def' not recognized")
	
	if(k <= 0 || (k%%1 != 0)) stop("Number of studies k, not a positive integer!")
	if(!search %in% c(0, 1, 2)) stop("Invalid search option")
	if(search < 2 && !(side %in% c(1, 2))) stop("side should be 1 or 2")
	if(any(t.vec < 0)) warning("Negative input thresholds! Using absolute value.")
	
	nsnp <- length(t.vec)
	if(!is.null(dim(ncase)) && ncol(ncase) != 1 && ncol(ncase) != nsnp) stop("Unexpected dim of ncase")
	if(!is.null(dim(ncntl)) && ncol(ncntl) != 1 && ncol(ncntl) != nsnp) stop("Unexpected dim of ncntl")
	
	tube.pval(t.vec, k, search, side, ncase = ncase, ncntl = ncntl
			  , rmat = rmat, pool = pool, cor.numr = cor.numr, sizes = rep(1, k), nsamp = nsamp
			  , sub.def = sub.def, sub.args = sub.args)
}


p.dlm <- function(t.vec, k, search, side, cor.def = NULL, cor.args=NULL, sizes=rep(1, k), sub.def=NULL, sub.args=NULL
		, wt.def=NULL, wt.args=NULL)
{
	if(is.null(cor.def) || !is.function(cor.def))
	{
		if(search == 0) cor.def <- cor.types
		if(search == 1) cor.def <- cor.meta
		if(search == 2) cor.def <- coef.meta
	}
	if(!is.null(sub.def) && !is.function(sub.def)) stop("'sub.def' not recognized")
	
	if(k <= 0 || (k%%1 != 0)) stop("Number of studies k, not a positive integer!")
	if(!search %in% c(0, 1, 2)) stop("Invalid search option")
	if(search < 2 && !(side %in% c(1, 2))) stop("side should be 1 or 2")
	if(search == 2) side <- 1

	if(any(t.vec < 0)) warning("Negative input thresholds! Using absolute value.")

	dlm.pval(t.vec, k, search, side, cor.def, cor.args, sizes=sizes, sub.def=sub.def, sub.args=sub.args)
}

dlm.pval <- function(t.vec, k, search, side, cor.def, cor.args, sizes = rep(1, k)
				, sub.def=NULL, sub.args=NULL, wt.def=NULL, wt.args=NULL)
{
	if(k == 1) return(2 * pnorm(t.vec, lower.tail=FALSE))

	NT <- length(t.vec)
	
	NS <- (prod(sizes + 1) - 1)	
	if(any(t.vec < 0)) t.vec <- abs(t.vec)

	low <- t.vec
	high <- rep(Inf, NT)
		
	r.vec2 <- r.vec3 <- NULL
	
	x <- rep(0, k)	
	kk <- length(sizes)
	xx <- rep(0, kk)
	cc <- c(0, cumsum(sizes[-kk]))
	
	ss <- rep(0, NT)
	i <- 1
	while (i <= NS)
	{

		pos <- max(which(xx < sizes))
		if(pos < kk)
		{
			xx[(pos + 1):kk] <- 0
			x[(cc[pos + 1] + 1):k] <- 0			
		}
		xx[pos] <- xx[pos] + 1
		x[cc[pos] + xx[pos]] <- 1
		set <- as.logical(x)
		NXX <- prod(choose(sizes, xx))
		
#		DEBUG
#		print(c(i, pos, cc[pos], xx, NXX))

#		Skip this subset
		if(!is.null(sub.def) && !do.call(sub.def, c(list(set), sub.args))) { i <- i + 1 ; next }

#		Matrix with neighboring subsets of x as columns
		nn.x <- (matrix(x, k, k) + diag(1, k)) %% 2
		nn.sub <- rep(TRUE, k)

		
#		Note: All zeros is not a valid neighbor
		if(sum(x) == 1)
		{
			nn.x <- nn.x[, (x == 0)]
			if(is.null(dim(nn.x))) nn.x <- matrix(nn.x, nrow = k)
			nn.sub <- rep(TRUE, k - 1)
		}
#		Valid neighbors
		if(!is.null(sub.def)) 
		{
		nn.set <- as.logical(nn.x)
		dim(nn.set) <- dim(nn.x)
		nn.sub <- nn.sub & apply(nn.set, 2, function(set1) do.call(sub.def, c(list(set1), sub.args)))
		}
#		Add a term to points with integral still below 1
		t.sub <- seq_len(NT)[ss < 1]

		if(length(t.sub) > 0 && search < 2)
		{
			cor.args$ncase <- matrix(cor.args$ncase, nrow=k, ncol=NT, byrow=FALSE)
			int <- vapply(t.sub, function(j)
						{
							ncor.args <- cor.args
							ncor.args$ncase <- cor.args$ncase[, j]
							ncor.args$ncntl <- ncor.args$ncntl[j]
							qxd.prod.int(low[j], high[j], search, qxd.prod.cor, side=side, x, matrix(nn.x[, nn.sub]
							, nrow=k, byrow=FALSE), cor.def, ncor.args)
						}, 0)
			ss[t.sub] <- ss[t.sub] + NXX * int
		}
		if(length(t.sub) > 0 && search == 2)
		{
			
#			Older code 2-sided search with 3 correlations instead of coefficients
#			nn.x2 <- diag(1, k)
#			sgn <- 1 - 2 * x
#			if(sum(x) == 1)
#			{
#				nn.x2 <- nn.x2[, (x == 0)]
#				sgn <- sgn[x == 0]
#				if(is.null(dim(nn.x2))) nn.x2 <- matrix(nn.x2, nrow = k)
#			}	
#
#			r.vec2 <- vapply(seq_along(nn.sub), function(j) do.call(cor.def
#			, c(list(x, nn.x2[, j], k, side), cor.args)), rep(0, k))
#			r.vec3 <- r.vec * r.vec2 + sgn[nn.sub] * sqrt((1 - r.vec * r.vec) * (1 - r.vec2 * r.vec2))
#			rho.mat <- cbind(r.vec, r.vec2, r.vec3)

			cor.args$ncase <- matrix(cor.args$ncase, nrow=k, ncol=NT, byrow=FALSE)
			int <- vapply(t.sub, function(j)
						{
							ncor.args <- cor.args
							ncor.args$ncase <- cor.args$ncase[, j]
							ncor.args$ncntl <- ncor.args$ncntl[j]
							qxd.prod.int(low[j], high[j], search, qxd.prod.coef, side=side, x=x, nn.x=matrix(nn.x[, nn.sub]
								, nrow=k, byrow=FALSE), cor.def, cor.args)
						}, 0)
						
			ss[t.sub] <- ss[t.sub] + NXX * int
		}
		if(length(t.sub) == 0) break
		i <- i + 1
	}

	ret <- pmin(1, ss)

	ret
}
	
qxd.prod.int <- function(low1, high1, search, int.func, side, x, nn.x, cor.def, cor.args)
{
	val <- 0

	if(low1 < Inf)
	{
		int <- integrate(function(zv)
						{
					 
						 prob1 <- side * int.func(zv=zv, search, side, x, nn.x, cor.def, cor.args)

						 (prob1 * dnorm(zv))
						}, lower=low1, upper=high1)
		if(int$message != "OK") { warning(int$message) ; val <- NA }
		else val <- int$value
	}
	val
}

qxd.prod.coef <- function(zv, search, side, x, nn.x, cor.def, cor.args)
{
	k <- length(x)
	npts <- length(zv)
	if(is.null(nn.x) || ncol(nn.x) == 0) return(rep(1, npts))	
	beta.mat <- matrix(drop(do.call(cor.def, c(list(x, nn.x, k), cor.args))), ncol=2, byrow=FALSE)


	if(any(is.na(beta.mat))) stop("NA in beta.mat")
	if(is.null(dim(beta.mat)) || ncol(beta.mat) != 2) stop("Expected two columns in beta.mat")
	
	kk <- nrow(beta.mat)
	b.s <- beta.mat[, 1]
	b.k <- beta.mat[, 2]

	lrr <- 0
	zv1 <- zv
	
	T1 <- (1/b.k) %o% zv1
	T2 <- (b.s/b.k) %o% zv1
	
	b.k2 <- b.k %o% rep(1, npts)
	
	r.vec <- (1 - b.s^2 - b.k^2)/(2 * b.s * b.k)
#	rho <- ((1 - b.k^2) + b.s^2)/(2 * b.s)
	
	mu.z <- r.vec %o% zv
	sd <- sqrt(1 - r.vec^2)
	
	if(search < 2)
	{
		if(side == 2)
		{
			low <- ifelse(b.k2 > 0, -T1 - T2, T1 - T2)
			high <- ifelse(b.k2 > 0, T1 - T2, - T1 - T2)
		}
		else
		{
			low <- ifelse(b.k2 > 0, -Inf, T1 - T2)
			high <- ifelse(b.k2 > 0, T1 - T2, Inf)
		}
		p1 <- ifelse(T1 == Inf, 0, pnorm(high, mean = mu.z, sd = sd))
		p0 <- ifelse(T1 == Inf, 0, pnorm(low, mean = mu.z, sd = sd))

	}
	if(search == 2)
	{
		low <- ifelse(b.k2 > 0, 0, pmax(0, T1 - T2))
		high <- ifelse(b.k2 > 0, T1 - T2, Inf)
		p1 <- ifelse(T1 == Inf | (b.k2 < 0 & T1 < T2), 0, pnorm(high, mean = mu.z, sd = sd))
		p0 <- ifelse(T1 == Inf | (b.k2 < 0 & T1 < T2), 0, pnorm(low, mean = mu.z, sd = sd))
	}

	pp <- ifelse(T1 == Inf, 1, (p1 - p0))		
	ss <- apply(pp, 2, function(x) { if(search == 2) (prod(2 * x)) else prod(x) })
	
	
#	DEBUG
#	print(rbind(zv,ss))
	
	if(any(is.na(ss))) stop("NA in integrand")
	ss
}

qxd.prod.cor <- function(zv, search, side, x, nn.x, cor.def, cor.args)
{
	k <- length(x)
	npts <- length(zv)
	if(is.null(nn.x) || ncol(nn.x) == 0) return(rep(1, npts))

	rho.mat <- do.call(cor.def, c(list(x, nn.x, k), cor.args))
	kk <- nrow(rho.mat)

	if(is.null(dim(rho.mat))) stop("rho.mat should be a matrix")
	if(search == 2 && ncol(rho.mat) != 3) stop("Expected 3 columns in rho.mat")
	if(search < 2 && ncol(rho.mat) != 1) stop("Expected 1 column in rho.mat")
	
	r.vec <- rho.mat[, 1]

	lrr <- 0
	zv1 <- zv
	
	if(search == 2)
	{
		zv11 <- rep(1, kk) %o% zv1
		r.vec2 <- rho.mat[, 2]
		r.vec3 <- rho.mat[, 3]
		beta <- (r.vec3 - r.vec * r.vec2)/(1 - r.vec * r.vec)
		beta2 <- beta %o% rep(1, kk)
	}
		
	mu.z <- r.vec %o% zv
	if(search == 2) mu.z1 <- (r.vec + beta * r.vec2) %o% zv

	sd <- sqrt(1 - r.vec^2)

	if(search < 2)
	{
		low <- rep(1, kk) %o% -abs(zv1)
		high <- rep(1, kk) %o% abs(zv1)
		p1 <- pnorm(high, mean = mu.z, sd = sd)
		if(side == 2) p0 <- pnorm(low, mean = mu.z, sd = sd)
		else p0 <- rep(0, kk, npts)
	}
	if(search == 2)
	{
		low <- ifelse(beta2 < 0, mu.z1, -Inf)
		high <- ifelse(beta2 < 0, abs(zv11), pmin(abs(zv11), mu.z1))
		p1 <- pnorm(high, mean = mu.z, sd = sd)
		p0 <- pnorm(low, mean = mu.z, sd = sd)
	}
	
	pp <- matrix((p1 - p0), nrow=kk, ncol=npts, byrow=FALSE)
	
	ss <- apply(pp, 2, function(x) { if(search == 2) (prod(2 * x)) else prod(x) })
	ss <- ifelse(zv1 == Inf, 1, ss)

#	DEBUG
#	print(rbind(zv,ss))

	if(any(is.na(ss))) stop("NA in integrand")
	ss
}


coef.meta <- function(x1, X2, k, ncase, ncntl, rmat=NULL, cor.numr=FALSE)
{
	if(is.null(rmat)) rmat <- diag(1, k)
	rneff <- sqrt(ncase * ncntl/(ncase + ncntl))

	
	nsnp <- length(ncase) %/% k
	if(is.null(dim(rneff))) dim(rneff) <- c(k, nsnp)
	
	x1 <- as.logical(x1)
	X2 <- as.logical(X2)

	nn <- length(X2)/k
	if(is.null(dim(X2))) dim(X2) <- c(k, nn)

	beta <- array(NA, c(nn, 2, nsnp))
	
	if(is.null(rmat)) rmat <- diag(1, k)
	
	xcom <- which(x1)
	xdel <- apply(X2, 2, function(x2) seq_len(k)[xor(x1, x2)])
	sgn <- (1 - 2 * x1[xdel]) %o% rep(1, nsnp)
	ncom <- length(xcom)
	ndel <- length(xdel)

	if(cor.numr)
	{
		rneff.com <- mySolve(matrix(rmat[xcom, xcom], ncom, ncom), matrix(rneff[xcom, ], ncom, nsnp, byrow=FALSE))
		rneff.del <- mySolve(matrix(rmat[xdel, xdel], ndel, ndel), matrix(rneff[xdel, ], ndel, nsnp, byrow=FALSE))
	} else 
	{
		rneff.com <- matrix(rneff[xcom, ], ncom, nsnp, byrow=FALSE)
		rneff.del <- matrix(rneff[xdel, ], ndel, nsnp, byrow=FALSE)
	}
	
	if(!is.vector(xdel)) stop("Coefficients defined for immediate neighbors only")
		
	sxx <- diag(t(rneff.com) %*% matrix(rmat[xcom, xcom], ncom, ncom) %*% rneff.com)
	sxd <- (matrix(rmat[xdel, xcom], ndel, ncom) %*% rneff.com) * (sgn * rneff.del)
	sdd <- rneff.del * rneff.del

	sall <- (rep(1, nn) %o% sxx) + 2 * sxd + sdd

	beta[, 1, ] <- ifelse(sall == 0, NA, sqrt(sxx/sall))
	beta[, 2, ] <- ifelse(sall == 0, NA, sgn * sqrt(sdd/sall))
	if(is.null(dim(beta))) dim(beta) <- c(nn, 2, nsnp)

#	rho <- rep(NA, ndel)
#	if(sxx != 0) rho <- ifelse(sall == 0, NA, (sxx + sxd)/sqrt(sxx * sall))
#	rho

	beta
}

cor.meta <- function(x1, X2, k, ncase, ncntl, rmat=NULL, cor.numr=FALSE)
{
	if(is.null(rmat)) rmat <- diag(1, k)
	rneff <- sqrt(ncase * ncntl/(ncase + ncntl))
	nsnp <- length(ncase) %/% k
	if(is.null(dim(rneff))) dim(rneff) <- c(k, nsnp)

	x1 <- as.logical(x1)
	n1 <- sum(x1)
	if(cor.numr) rneff1 <- mySolve(matrix(rmat[x1, x1], n1, n1), matrix(rneff[x1, ], n1, nsnp, byrow=FALSE))
	else rneff1 <- matrix(rneff[x1, ], n1, nsnp, byrow=FALSE)

	cor.func <- function(x2)
	{	
		x2 <- as.logical(x2)
		n2 <- sum(x2)
		if(cor.numr) rneff2 <- mySolve(matrix(rmat[x2, x2], n2, n2), matrix(rneff[x2, ], n2, nsnp, byrow=FALSE))
		else rneff2 <- rneff[x2, ]
		sx12 <- t(matrix(rneff1, ncol=nsnp)) %*% matrix(rmat[x1, x2], n1, n2) %*% matrix(rneff2, ncol = nsnp)
		sx11 <- t(matrix(rneff1, ncol=nsnp)) %*% matrix(rmat[x1, x1], n1, n1) %*% matrix(rneff1, ncol = nsnp)
		sx22 <- t(matrix(rneff2, ncol=nsnp)) %*% matrix(rmat[x2, x2], n2, n2) %*% matrix(rneff2, ncol = nsnp)

		rho <- ifelse(sx11 == 0 | sx22 == 0, NA, sx12/sqrt(sx11 * sx22))
		rho
	}

	rho.mat <- matrix(apply(X2, 2, cor.func), ncol = nsnp, byrow = TRUE)

	rho.mat
}

cor.types <- function(x1, X2, k, ncase, ncntl, pool)
{
	nsnp <- length(ncntl)
	if(is.null(dim(ncase))) dim(ncase) <- c(k, nsnp)

	x1 <- as.logical(x1)
	x2 <- as.logical(X2)
	
	if(is.null(dim(X2))) dim(X2) <- c(k, length(X2)/k)
	nn <- ncol(X2)
	
#	if(any(x1 & !x2) && any(!x1 & x2)) stop("Correlation defined for subset/superset only")
	
	ncase.com <- apply(X2, 2, function(x2) colSums(matrix(ncase[x1 & x2,], ncol=nsnp)))
	ncase.all <- apply(X2, 2, function(x2) colSums(matrix(ncase[x1 | x2,], ncol=nsnp)))
	N <- (colSums(ncase) + ncntl) %o% rep(1, nn)
	
	if(pool == FALSE) rho <- sqrt((ncase.com * (ncase.all + ncntl))/(ncase.all * (ncase.com + ncntl)))
	else rho <- sqrt((ncase.com * (N - ncase.all))/((ncase.all) * (N - ncase.com)))

	rho <- matrix(rho, nn, nsnp, byrow=TRUE)
	rho
}

tubeSim <- function(x, t0, nsamp, rmat0, neff0, cor.numr=FALSE)
{
	k <- length(x)
	nsnp <- length(t0)

	Z <- array(0, c(k, nsamp, nsnp))
	x <- as.logical(x)
	r1 <- (which(x))[1]
	r2 <- seq_len(k)[-r1]

	for(j in seq_len(nsnp))
	{
		if(j == 1 || ncol(rmat0) > 1 || ncol(neff0) > 1)
		{
			rmat <- matrix(rmat0[, (j - 1) %% ncol(rmat0) + 1], k, k)
			rneff <- sqrt(neff0[, (j - 1) %% ncol(neff0) + 1])
			if(cor.numr)
			{
				rr <- rep(0, k)
				rr[x] <- mySolve(rmat[x, x], rneff[x])
			}
			else rr <- (rneff * x)
		
			A <- diag(k)
			A[r1, ] <- rr/sqrt(sum(matrix(rr, nrow=1) %*% rmat %*% matrix(rr, ncol=1)))
			A <- A[c(r1, r2), ]

			Sigma <- A %*% rmat %*% t(A)
			Sig <- Sigma[(2:k), (2:k)] -  ((1/Sigma[1, 1]) * outer(Sigma[(2:k), 1], Sigma[(2:k), 1]))	

			ev <- eigen(Sig, symmetric = TRUE)

			if (!all(ev$values >= -sqrt(.Machine$double.eps) * abs(ev$values[1])))
			{
				warning("Sigma is numerically not positive definite")
			}
			Sigroot <- ev$vectors %*% diag(sqrt(ev$values), length(ev$values)) %*% t(ev$vectors)
		}
	
		W1 <- rtnorm(nsamp, mean = 0, sd = sqrt(Sigma[1, 1]), lower = t0[j])
		mu <- outer(Sigma[(2:k), 1]/Sigma[1, 1], W1)
		
		W2 <- t(matrix(rnorm(nsamp * (k - 1)), nrow = nsamp) %*% Sigroot) + mu				
		
		W <- rbind(W1, W2)
	
		Z[, , j] <- solve(A) %*% W
	}
	Z
}


checkSim1 <- function(Z, t1, t2, rmat0, neff0, cor.numr=FALSE, sub.def=NULL, sub.args=NULL)
{
	k <- dim(Z)[1]
	nsamp <- dim(Z)[2]
	nsnp <- dim(Z)[3]
					

	x <- rep(0, k)
	fm <- matrix(0, nsamp, nsnp)
	i <- 1
	while(i <= ((2^k)-1))
	{		
		pos <- max(which(x == 0))
		x[pos:k] <- 0
		x[pos] <- 1
		set <- as.logical(x)

#		Skip this subset
		if(!is.null(sub.def) && !do.call(sub.def, c(list(set), sub.args))) { i <- i + 1 ; next }
		
		for(j in seq_len(nsnp))
		{
			if(cor.numr)
			{
				if(j == 1 || ncol(rmat0) > 1 || ncol(neff0) > 1)
				{
					rmat <- matrix(rmat0[, (j - 1) %% ncol(rmat0) + 1], k, k)
					rneff <- sqrt(neff0[, (j - 1) %% ncol(neff0) + 1])
					denr <- sqrt(matrix(rneff[set], nrow=1) %*% mySolve(rmat[set, set], matrix(rneff[set], ncol=1)))
				}
				numr <- drop(matrix(rneff[set], nrow = 1) %*% mySolve(rmat[set, set], Z[set, , j]))
			}
			else
			{
				if(j == 1 || ncol(rmat0) > 1 || ncol(neff0) > 1)
				{
					rmat <- matrix(rmat0[, (j - 1) %% ncol(rmat0) + 1], k, k)
					rneff <- sqrt(neff0[, (j - 1) %% ncol(neff0) + 1])

					denr <- sqrt(matrix(rneff[set], nrow=1) %*% rmat[set, set] %*% matrix(rneff[set], ncol=1))

				}

				numr <- drop(matrix(rneff[set], nrow = 1) %*% Z[set, , j])
			}
	
			f1 <- ((numr/denr) > t1[j])
			f2 <- ((-numr/denr) > t2[j])

			fm[, j] <- fm[, j] + (f1 + f2)
		}

		i <- i + 1		
	}

	gm <- apply(fm, 2, function(x) mean(ifelse(x > 0, 1/x, 0)))

	gm
	
}

checkSim2 <- function(Z1, Z2, t1, t2, rmat0, neff0, cor.numr=FALSE, sub.def=NULL, sub.args=NULL)
{
	k <- dim(Z1)[1]
	nsamp <- dim(Z1)[2]
	nsnp <- dim(Z1)[3]
						
	x <- rep(0, k)
	
	fm1 <- matrix(0, nsamp, nsnp)
	fm2 <- matrix(0, nsamp, nsnp)
	fm3 <- matrix(0, nsamp, nsnp)
	
	i <- 1
	while(i <= ((2^k)-1))
	{		
		pos <- max(which(x == 0))
		x[pos:k] <- 0
		x[pos] <- 1
		set <- as.logical(x)
					
#		Skip this subset
		if(!is.null(sub.def) && !do.call(sub.def, c(list(set), sub.args))) { i <- i + 1 ; next }

		for(j in seq_len(nsnp))
		{
			if(cor.numr)
			{
				if(j == 1 || ncol(rmat0) > 1 || ncol(neff0) > 1)
				{
					rmat <- matrix(rmat0[, (j - 1) %% ncol(rmat0) + 1], k, k)
					rneff <- sqrt(neff0[, (j - 1) %% ncol(neff0) + 1])
					denr <- sqrt(matrix(rneff[set], nrow=1) %*% mySolve(rmat[set, set], matrix(rneff[set], ncol=1)))
				}
				numr1 <- drop(matrix(rneff[set], nrow = 1) %*% mySolve(rmat[set, set], Z1[set, , j]))
				numr2 <- drop(matrix(rneff[set], nrow = 1) %*% mySolve(rmat[set, set], Z2[set, , j]))
			}
			else
			{
				if(j == 1 || ncol(rmat0) > 1 || ncol(neff0) > 1)
				{
					rmat <- matrix(rmat0[, (j - 1) %% ncol(rmat0) + 1], k, k)
					rneff <- sqrt(neff0[, (j - 1) %% ncol(neff0) + 1])
					denr <- sqrt(matrix(rneff[set], nrow=1) %*% rmat[set, set] %*% matrix(rneff[set], ncol=1))
				}
				numr1 <- drop(matrix(rneff[set], nrow = 1) %*% Z1[set, , j])
				numr2 <- drop(matrix(rneff[set], nrow = 1) %*% Z2[set, , j])
			}
			
			f11 <- ((numr1/denr) > t1[j, 1])
			f12 <- ((-numr1/denr) > t2[j, 1])
			fm1[, j] <- fm1[, j] + (f11 + f12)
			
			f21 <- ((numr2/denr) > t1[j, 2])
			f22 <- ((-numr2/denr) > t2[j, 2])
			fm2[, j] <- fm2[, j] + (f21 + f22)
			
			f31 <- ((numr2/denr) > t1[j, 3])
			f32 <- ((-numr2/denr) > t2[j, 3])
			fm3[, j] <- fm3[, j] + (f31 + f32)			
		}
		
		i <- i + 1		
	}
	gm1 <- apply(fm1, 2, function(x) mean(ifelse(x > 0, 1/x, 0)))
	gm2 <- apply(fm2, 2, function(x) mean(ifelse(x > 0, 1/x, 0)))
	gm3 <- apply(fm3, 2, function(x) mean(ifelse(x > 0, 1/x, 0)))
		
	cbind(gm1, gm2, gm3)
}


tube.pval <- function(t.vec, k, search, side, ncase, ncntl, pool, rmat = NULL
					  , cor.numr = FALSE, sizes = rep(1, k), nsamp = 50, sub.def=NULL, sub.args=NULL)
{	
	if(k == 1) return(side * pnorm(t.vec, lower.tail=FALSE))
	
	nsnp <- length(t.vec)

	if(is.null(dim(ncase))) ncase <- matrix(ncase, ncol = nsnp, byrow=FALSE)
	if(is.null(dim(ncntl))) ncntl <- matrix(ncntl, ncol = nsnp, byrow=FALSE)

	if(search == 1 || search == 2)
	{
		neff <- (ncase * ncntl)/(ncase + ncntl)
		if(is.null(rmat)) rmat <- diag(k)
		rmat <- matrix(as.vector(rmat), ncol=1)
	}

	if(search == 0)
	{
		N <- apply(ncase, 2, sum) + ncntl
		ncntl1 <- matrix(ncntl, k, nsnp, byrow=TRUE)
		if(pool == FALSE)
		{
			neff <- (ncase * ncntl1)/(ncase + ncntl1)
			rmat <- vapply(seq_len(nsnp)
						, function(j)
						   {
						   rtmp <- outer(sqrt(ncase[,j]/(ncase[,j] + ncntl[1, j])), sqrt(ncase[,j]/(ncase[,j]+ncntl[1, j])))
						   diag(rtmp) <- 1
						   as.vector(rtmp)
						   }, matrix(1, k, k))
		}
		if(pool == TRUE) 
		{
			N1 <- ncase + ncntl1
			neff <- (ncase * (N1 - ncase))/N1
			rmat <- vapply(seq_len(nsnp)
						, function(j)
						   {
								rtmp <- (-1) * outer(ncase[, j]/sqrt(neff[, j]), ncase[, j]/sqrt(neff[, j]))/N[j]
								diag(rtmp) <- 1
								as.vector(rtmp)
							}, matrix(1, k, k))
		}
#		Note: hard coded
		cor.numr <- TRUE
		search <- 1
	}
	
	kk <- length(sizes)
	cc <- c(0, cumsum(sizes[-kk]))
	
	nn <- (prod(sizes + 1) - 1)
	
	x <- rep(0, k)
	xx <- rep(0, kk)
	
	prob1 <- pnorm(t.vec, lower.tail=FALSE)
	zeros <- rep(0, nsnp)
	infs <- rep(Inf, nsnp)				
					
	jj <- 1
	pv <- rep(0, nsnp)
	pv0 <- rep(0, nsnp)

	while (jj <= nn)
	{
		pos <- max(which(xx < sizes))
		if(pos < kk)
		{
			xx[(pos + 1):kk] <- 0
			x[(cc[pos + 1] + 1):k] <- 0			
		}

		xx[pos] <- xx[pos] + 1
		x[cc[pos] + xx[pos]] <- 1
		set <- as.logical(x)

#		Skip this subset
		if(!is.null(sub.def) && !do.call(sub.def, c(list(set), sub.args))) { jj <- jj + 1 ; next }
				
		mm <- prod(choose(sizes, xx))
	
		if(search == 1)
		{
			Z1 <- tubeSim(x = x, t0 = t.vec, nsamp = nsamp, rmat0 = rmat, neff0 = neff)

			p1 <- checkSim1(Z1, t1 = t.vec, t2 = t.vec, rmat0 = rmat, neff0 = neff
							, sub.def = sub.def, sub.args = sub.args) * (prob1 * mm)

			p2 <- if(side == 2) p1 else rep(0, nsnp)
			pv <- pv + (p1 + p2)
		}
		if(search == 2)
		{
			Z1 <- tubeSim(x = (x), t0 = t.vec, nsamp = nsamp, rmat0 = rmat, neff0 = neff)
			
			Z2 <- tubeSim(x = (x), t0 = zeros, nsamp = nsamp, rmat0 = rmat, neff0 = neff)

			res <- checkSim2(Z1, Z2, t1 = cbind(t.vec, zeros, zeros), t2 = cbind(zeros, t.vec, infs)
							 , rmat0 = rmat, neff0 = neff, sub.def = sub.def, sub.args = sub.args)
			p1 <- res[, 1] * (prob1 * mm)
			p2 <- res[, 2]  * (0.5 * mm)
			p0 <- res[, 3] * (0.5 * mm)
			
			pv <- pv + (p1 + (p2 - p0))
			pv0 <- pv0 + p0
		}
		
		jj <- jj + 1
	}
#	pv0 <- 1 - (1/2^k)	
#   print(c(pv, pv0, 1 - (1/(2^k))))
	
	if(search == 2) pv <- pmax(pv, 0)/pmax((1/2^k), 1 - pv0)
	
	pv
}

test_p.dlm <- function() {
 
  cor.def <- function(subset, neighbors, k, ncase, ncntl) {
    n <- ncol(neighbors)
    mat <- matrix(subset, nrow=k, ncol=n, byrow=FALSE)
    cor <- (mat + neighbors)*(1:k)/(k^2)
    cor <- colSums(cor)
    cor <- cor/max(cor)
    dim(cor) <- c(n, 1)

    cor  
  }
  sub.def <- function(logicalVec) {
    sum <- sum(logicalVec)  
    ret <- all(logicalVec[1:sum])
    ret
  }

  k     <- 3
  t.vec <- 1:k

  res1 <- p.dlm(t.vec, k, 1, 2, cor.def=cor.def, sub.def=sub.def,
         cor.args=list(ncase=rep(1000, k), ncntl=rep(1000,k)))
  res2 <- p.dlm(t.vec, k, 2, 2, cor.def=cor.def, sub.def=sub.def,
         cor.args=list(ncase=rep(1000, k), ncntl=rep(1000,k)))

  vec1 <- c(0.889214710, 0.133102631, 0.008039759)
  vec2 <- c(0.0761039412, 0.0119134489, 0.0006007941)

  checkEquals(sum(abs(res1 - vec1) < 1e-6), k)
  checkEquals(sum(abs(res2 - vec2) < 1e-6), k)
}

scr_transform_in_block <- function(snp, traits.lab, beta.hat, sigma.hat, cor=NULL, n.eff=NULL, p.bound=1)
{
    k <- length(traits.lab)
    if((mode(beta.hat)!="numeric") || (length(beta.hat) != k))
        stop("beta.hat should be numeric vector of length #trait")
    if((mode(sigma.hat)!="numeric") || (length(sigma.hat) != k))
        stop("sigma.hat should be numeric vector of length #trait")

    names(beta.hat) <- traits.lab
    names(sigma.hat) <- traits.lab

    if(!is.null(n.eff))
    {
        ord <- order(n.eff)
        beta.mat <- beta.hat[ord]
        sigma.mat <- sigma.hat[ord]
        t.lab <- traits.lab[ord]
    }
    if(p.bound < 1){
        c0 <- qnorm(p.bound/2, lower.tail=FALSE)
    } else {
        return(list(beta.mat=beta.mat, sigma.mat=sigma.mat))
    }

    if(!is.null(cor))
    {
        cor.ord = cor[ord,ord]
        U <- chol(cor.ord)
        Ui <- solve(U)
    } else {
        Ui <- diag(1, k)
    }
    zz <- beta.mat/sigma.mat
    zz.o <- zz %*% Ui

    # Orthogonalization for two-sided ASSET
    # pp1: P(|Z|>z | |Z|>c0)
    pp1 <- pmax(pmin(2 * pnorm(abs(zz.o), lower.tail=FALSE)/p.bound, 0.9999999), .Machine$double.xmin)
    scr <- (abs(zz.o) > c0)
    zz0 = sign(zz.o)*qnorm(pp1/2, lower.tail=FALSE)

    colnames(scr) <- t.lab

    zzn <- zz0 %*% U

    beta1 <- as.vector(zzn * sigma.mat)
    names(beta1) <- t.lab

    beta.scr <- beta1[scr]
    sigma.scr <- sigma.mat[scr]

    return(list(beta.scr=beta.scr, sigma.scr=sigma.scr))
}

scr_transform = function(betahat, SE, SNP, traits_i, cor, block, Neff, scr_pthr = 0.05){
    traits_i_block = lapply(block, function(x) traits_i[traits_i%in%x])
    traits_i_block = traits_i_block[vapply(traits_i_block,length, FUN.VALUE = numeric(1)) >=2]

    betahat_orth = vector(length = 0)
    sigma_orth = vector(length = 0)

    if (length(traits_i_block)>0){
        for (j in seq_along(traits_i_block)){
            scr = scr_transform_in_block(SNP, traits_i_block[[j]], beta.hat = betahat[traits_i_block[[j]]],
                                          sigma.hat = SE[traits_i_block[[j]]], n.eff = Neff[traits_i_block[[j]]],
                                          cor = cor[traits_i_block[[j]],traits_i_block[[j]]], p.bound = scr_pthr)
            betahat_orth = c(betahat_orth, scr$beta.scr)
            sigma_orth = c(sigma_orth, scr$sigma.scr)
        }
    }

    betahat = betahat[!(names(betahat)%in%unlist(traits_i_block))]
    SE = SE[!(names(SE)%in%unlist(traits_i_block))]

    # two-sided correction
    scr = (2*pnorm(abs(betahat/SE),lower.tail=FALSE))<scr_pthr
    betahat = betahat[scr]
    SE = SE[scr]
    pp1 = pmin(2*pnorm(abs(betahat/SE),lower.tail=FALSE)/scr_pthr, 0.9999999)
    betahat_orth = c(betahat_orth, SE*sign(betahat)*abs(qnorm(pp1/2,lower.tail=FALSE)))
    sigma_orth = c(sigma_orth, SE)

    traits_i=names(betahat_orth)

    return(list(betahat_orth = betahat_orth, sigma_orth = sigma_orth))
}

#' Fast ASSET using pre-screening
#' @description This function implements a fast version of ASSET for analysis of a large number of traits. It accelerates the computation by restricting subset search among the traits with suggestive level of associations. The traits are selected by a liberal p-value threshold. The input is GWAS summary statistics for one SNP. See details for more information.
#' @param snp A character string giving the SNP name to be analyzed. No default.
#' @param traits.lab A character vector giving the names/identifiers of the k studies/traits being analyzed. The order of this vector must match the columns of beta.hat and sigma.hat No default.
#' @param beta.hat A numeric vector of length k giving the coefficients obtained from the analysis of that SNP across the k studies/traits. No default.
#' @param sigma.hat A vector of same dimension as beta.hat, giving the corresponding standard errors. No default.
#' @param Neff A numeric vector of same dimension as beta.hat, giving the effective sample size of each study. For continuous traits, the effective sample size is the total sample size; for binary traits, the effective sample size is Ncase*Ncontrol/(Ncase+Ncontrol).
#' @param cor A matrix of dimension k by k storing the correlation of z-statistics under the null hypothesis. It can be estimated using LD score regression (https://github.com/bulik/ldsc). For example, element \code{(j,k)} is the LD score regression intercept between traits \code{j} and {k}. Diagonal elements are equal to 1. Set to identity matrix if different studies do not have overlapping samples.
#' @param block A list of character vectors. Each element is a vector of study/trait names that fall into the same correlation block based on \code{cor}. Studies from different blocks are treated as independent. Studies that are not in \code{block} are treated as independent from other studies.
#' @param scr_pthr P-value threshold for pre-screening. Only traits with p-value < scr_pthr are retained. Default to 0.05.
#'
#' @details The standard ASSET (\code{h.traits}) which searches through all subsets can be computationally intractable for analyzing a large number of traits. \code{fast_asset} reduces the computational burden by the following procedure: (1) De-correlate the z-statistics associated with different traits using the correlation matrix (\code{cor}); (2) select the set of traits using a liberal threshold (p<0.05 by default) of the de-correlated z-statistics; (3) adjust the de-correlated z-statistics for the pre-selection independently across different traits; (4) re-introduce the correlation using the matrix \code{cor} and supply the adjusted statistics to standard ASSET.
#'
#' @return A list of the same format as the output of \code{h.traits}.
#'
#' @references Guanghao Qi, Surya Chhetri, Elizaveta Naydanova, Debashree Ray, Diptavo Dutta, Alexis Battle, Samsiddhi Bhattacharjee and Nilanjan Chatterjee. "Genome-wide Multi-trait Analysis Across 116 Studies Identifies Complex Patterns of Pleiotropy and Unique Trait-Specific Loci". In preparation (2021).
#'
#' @examples
#' data("ex_fast_asset", package="ASSET")
#' block <- create_blocks(ldscintmat)
#' test <- fast_asset(snp=SNP, traits.lab=traits, beta.hat=betahat, sigma.hat=SE
#'                 , Neff=Neff, cor=ldscintmat, block=block, scr_pthr=0.05)
#' @import ASSET
#' @export
fast_asset <- function(snp, traits.lab, beta.hat, sigma.hat, Neff, cor, block, scr_pthr=0.05){
    ind <- (!is.na(beta.hat)) & (!is.na(sigma.hat))
    beta.hat <- beta.hat[ind]
    sigma.hat <- sigma.hat[ind]
    Neff <- Neff[ind]
    traits_i <- traits.lab[ind]
    names(beta.hat) <- names(sigma.hat) <- names(Neff) <- traits_i

    # Pre-screening is only implemented when data for >=2 traits are available
    if (sum(ind)>=2){
        cormat <- cor[ind,ind]
        rownames(cormat) <- colnames(cormat) <- traits_i

        # Pre-screen and adjust the summary statistics
        dt_scr <- scr_transform(betahat=beta.hat, SE=sigma.hat, SNP=snp, traits_i=traits_i,
                                cor = cormat, block, Neff=Neff, scr_pthr = 0.05)
        if (sum(dt_scr$betahat_orth>0)>16 | sum(dt_scr$betahat_orth<=0)>16){
            print("Too many traits passed pre-screening, subset search can be slow. Consider using a lower scr_pthr.")
        }

        betahat_orth <- dt_scr$betahat_orth
        sigma_orth <- dt_scr$sigma_orth
        traits_i <- names(betahat_orth)
        rm(dt_scr)

        if (length(traits_i)>=2){
            res.asset <- h.traits(snp.vars=snp, traits.lab=traits_i,
                                 beta.hat=betahat_orth, sigma.hat=sigma_orth, ncase=2/sigma_orth^2,
                                 ncntl=2/sigma_orth^2, cor=cormat[traits_i,traits_i],
                                 side=2, search=2, cor.numr = FALSE)
        } else if (length(traits_i)==1){
            res.asset <- h.traits(snp.vars=snp, traits.lab=traits_i,
                                 beta.hat=betahat_orth, sigma.hat=sigma_orth, ncase=2/sigma_orth^2,
                                 ncntl=2/sigma_orth^2, side=2, search=2)
        } else if (length(traits_i)==0){
            stop("No trait passed pre-screening. Use a higher scr_pthr or standard ASSET.")
        }
    } else if (sum(ind)==1){
        res.asset <- h.traits(snp.vars=snp, traits.lab=traits_i,
                             beta.hat=beta.hat, sigma.hat=sigma.hat, ncase=2/sigma.hat^2,
                             ncntl=2/sigma.hat^2, side=2, search=2)
    } else{
        stop("Data are missing for every trait.")
    }

    return(res.asset)
}

#' Create blocks from correlation matrix
#' @description Partition the set of traits into blocks of correlated traits using hierarchical clustering.
#' @param cormat A named k by k correlation matrix of z-statistics with row and column names being the names of studies/traits.
#' @param cor_thr Threshold of correlation to divide the set of traits into blocks. Z-statistics with correlation less than \code{cor_thr} are treated as uncorrelated.
#' @return A list of character vectors. Each element is a vector of study/trait names that fall into the same correlation block based on \code{cormat}. Studies from different blocks are treated as independent. Studies that are not in the list are treated as independent from other studies.
#' @examples
#' data("ex_fast_asset", package="ASSET")
#' block <- create_blocks(ldscintmat)
#' @export
create_blocks <- function(cormat, cor_thr=0.2){
    # Hierarchical clustering
    corrdist <- as.dist(1-abs(cormat))
    hc <- hclust(corrdist)
    htree <- cutree(hc, h=1-cor_thr) # Criterion: corr>0.2
    block <- as.integer(names(table(htree))[table(htree)>=2])
    block <- lapply(block, function(x) names(htree)[htree==x])

    return(block)
}

# Nov 01 2011  Add function h.forest


myInv <- function(A){

	Ainv <- try(solve(A))
	if (inherits(Ainv, "try-error")) Ainv <- ginv(A)
	Ainv
}

mySolve <- function(A, B){

	AinvB <- try(solve(A, B))
	if (inherits(AinvB, "try-error")) AinvB <- ginv(A) %*% B 
	AinvB
}

corr.mat.logit <- function(nmat11, nmat00, nmat10=NULL, nmat01=NULL){

	k <- nrow(nmat11)
	if(is.null(nmat10)) nmat10 <- 0
	if(is.null(nmat01)) nmat01 <- 0
	
	nvec0 <- diag(nmat00)
	nvec1 <- diag(nmat11)
	nvec <- nvec0 + nvec1
	
	neff <- (nvec0 * nvec1)/nvec
	rneff <- sqrt(neff)
	
	rmat <- (nmat11 * outer(1/nvec1, 1/nvec1) + nmat00 * outer(1/nvec0, 1/nvec0)
			 -nmat10 * outer(1/nvec1, 1/nvec0) - nmat01 * outer(1/nvec0, 1/nvec1)) * sqrt(outer(neff, neff))
	rmat
}

# Function to identify rows with missing values of certain variables. 
findMiss.vars <- function(x, vars=NULL, miss=NA) {

	if(is.null(dim(x))) dim(x) <- c(length(x), 1)
	if (is.null(vars)) vars <- seq_len(ncol(x))
	
  ##SMB: changed this a bit to speed it up
	temp <- rep(TRUE, times=nrow(x)) 
  if(!is.na(miss)) x[x == miss] <- NA
	for (var in vars) temp <- temp & !(is.na(x[, var]))
	##for (var in vars) temp <- temp & !(x[, var] %in% miss)
	
	temp
	
} # END: findMiss.vars


z.max <- function(k, snp.vars, side, meta.def, meta.args, th = rep(-1, length(snp.vars))
			, sub.def = NULL, sub.args = NULL, wt.def=NULL, wt.args=NULL) {
			
	nsnp <- length(snp.vars)
	snp.sub <- seq_len(nsnp)
	
	if(length(th) == 1) th = rep(th, nsnp)
	if(length(th) != nsnp) stop("Expected one threshold or a threshold for each SNP")
	
	x <- rep(0, k)
	opt.s <- matrix(FALSE, nsnp, k)
	opt.s[, k] <- 1
	
	opt.z <- rep(0, nsnp)
	nopt <- rep(0, nsnp)
	ztmp <- opt.z
	
	i <- 1
	ipos <- k
    subsetCount <- 0
	while(i <= ((2^k) - 1))
	{	
		ipos <- max(which(x == 0))
		x[ipos:k] <- 0
		x[ipos] <- 1
		set <- as.logical(x)

		if(!is.null(sub.def)) if(! do.call(sub.def, c(list(set), sub.args))){ i <- i + 1 ; next }
	    subsetCount <- subsetCount + 1
#		sub <- which(set)
		nsub <- sum(set)

		ztmp <- do.call(meta.def, c(list(as.logical(set), snp.vars[snp.sub]), meta.args))$z
#		print(c(i, set, ztmp, opt.z))
	
		ztmp[is.na(ztmp) | is.nan(ztmp)] <- 0
		
		lrr <- 0
		
		#if(side == 2) pos <- (pnorm(abs(ztmp), 0, 1, lower=FALSE, log=TRUE) - pnorm(abs(opt.z[snp.sub]), 0, 1, lower=FALSE, log=TRUE) < lrr)
		#else pos <- (pnorm(ztmp, 0, 1, lower=FALSE, log=TRUE) - pnorm(opt.z[snp.sub], 0, 1, lower=FALSE, log=TRUE) < lrr)
        if(side == 2) {
          pos <- pnorm(abs(ztmp), 0, 1, lower.tail=FALSE, log.p=TRUE) <
                 pnorm(abs(opt.z[snp.sub]), 0, 1, lower.tail=FALSE, log.p=TRUE)
        } else {
          pos <- pnorm(ztmp, 0, 1, lower.tail=FALSE, log.p=TRUE) <
                 pnorm(opt.z[snp.sub], 0, 1, lower.tail=FALSE, log.p=TRUE)
        }

		npos <- sum(pos)

	
		if(npos > 0)
		{
            jj          <- snp.sub[pos]   
			opt.z[jj]   <- ztmp[pos]
			opt.s[jj, ] <- matrix(set, npos, k, byrow=TRUE)
			nopt[jj]    <- nsub

		}
		
		if(side == 2) ltmp <- (th[snp.sub] < 0 | (abs(opt.z[snp.sub]) < th[snp.sub]))
		else ltmp <- (th[snp.sub] < 0 | (opt.z[snp.sub] < th[snp.sub]))
	
		snp.sub <- snp.sub[ltmp]
		if(length(snp.sub) < 1) break
		
		i <- i + 1
	}
#	print(c(i, set, ztmp, opt.z))
#	stop()

    # Change here
	#opt.z[opt.z == 0] <- NA
    
    opt.z[!is.finite(opt.z)] <- 0
    if (all(opt.z == 0)) opt.s[] <- 0

	ret <- list(opt.z = opt.z, opt.s = opt.s, subsetCount=subsetCount)

	ret
	
}

getCI <- function(beta, sd, level=0.05) {

	half.width <- qnorm(1 - level/2) * sd
	low <- beta - half.width
	high <- beta + half.width
	return(data.frame(mid = exp(beta), low=exp(low), high=exp(high)))
}

h.summary <- function(rlist, level = 0.05, digits = 3){

	frlist <- list()
	nmlist <- NULL
	
	rnames <- names(rlist)
	if(is.null(rnames)) rnames <- paste("Results-", seq_along(rlist), sep="")

	for(i in seq_along(rlist))
	{
		if(!is.null(rlist[[i]]))
		{
			res <- rlist[[i]]
			#if(!is.list(res)) stop("Expected a list")
            if (!is.list(res)) next

			len <- length(res$pval)
			#if(len == 0) { warning("Empty p-value vector") ; next }
            if(len == 0) next 

			svars <- names(res$pval)
			if(is.null(svars)) svars <- paste("SNP-", seq_len(len), sep="")
			spheno <- NULL
			
			if(!is.null(res$beta))
			{
				if(length(res$beta) != len || length(res$sd) != len) stop("beta and sd expected")
				CI <- getCI(res$beta, res$sd, level = level)
				#mat <- signif(cbind(res$pval, CI$mid, CI$low, CI$high), digits=digits)
                mid11 <- round(CI$mid, digits=digits)
                low11 <- round(CI$low, digits=digits)
                high11 <- round(CI$high, digits=digits)
                #mat <- cbind(res$pval, CI$mid, CI$low, CI$high)
                mat <- cbind(res$pval, mid11, low11, high11)
				colnames(mat) <- c("Pvalue", "OR", "CI.low", "CI.high")
			}

			if(!is.null(res$beta.1) && !is.null(res$beta.2))
			{
				if(length(res$pval.1) != len || length(res$beta.1) != len || length(res$sd.1) != len) stop("pval.1, beta.1 and sd.1 expected")
				CI.1 <- getCI(res$beta.1, res$sd.1, level = level)
				if(length(res$pval.2) != len || length(res$beta.2) != len || length(res$sd.2) != len) stop("pval.2, beta.2 and sd.2 expected")
				CI.2 <- getCI(res$beta.2, res$sd.2, level = level)

				#mat <- signif(cbind(res$pval, res$pval.1, res$pval.2, CI.1$mid, CI.1$low, CI.1$high
				#					, CI.2$mid, CI.2$low, CI.2$high), digits=digits)
                mat <- cbind(res$pval, res$pval.1, res$pval.2, CI.1$mid, CI.1$low, CI.1$high
									, CI.2$mid, CI.2$low, CI.2$high)
				colnames(mat) <- c("Pvalue", "Pvalue.1", "Pvalue.2", "OR.1", "CI.low.1", "CI.high.1", "OR.2", "CI.low.2", "CI.high.2")
                for (ii in 4:9) mat[, ii] <- round(mat[, ii], digits=digits)
			}

			if(!is.null(res$pheno))
			{
				if(nrow(res$pheno) != len) stop("pheno expected for all SNPs")
				types.lab <- colnames(res$pheno)
				if(is.null(types.lab)) types.lab <- seq_len(ncol(res$pheno))
				spheno <- matrix(apply(res$pheno, 1, function(x) paste(types.lab[x], collapse=",")), ncol = 1)
				colnames(spheno) <- "Pheno"
			}

			if(!is.null(res$pheno.1) && !is.null(res$pheno.2))
			{
				if(nrow(res$pheno.1) != len || nrow(res$pheno.2) != len) stop("pheno.1 and pheno.2 expected for all SNPs")
				types.lab <- colnames(res$pheno.1)
				if(is.null(types.lab)) types.lab <- seq_len(ncol(res$pheno.1))
				spheno.1 <- apply(res$pheno.1, 1, function(x) paste(types.lab[x], collapse=","))
				spheno.2 <- apply(res$pheno.2, 1, function(x) paste(types.lab[x], collapse=","))
				spheno <- cbind(spheno.1, spheno.2)
				colnames(spheno) <- c("Pheno.1", "Pheno.2")
			}
			
			if(is.null(spheno)) fres <- cbind(data.frame(SNP = svars), data.frame(mat))
			else fres <- cbind(data.frame(SNP = svars), data.frame(mat), data.frame(spheno))
			
			rownames(fres) <- NULL
			
			frlist <- c(frlist, list(fres))
			nmlist <- c(nmlist, rnames[i])
		}
	}
	names(frlist) <- nmlist
	frlist
}


h.forest <- function(k, snp.var, t.lab, rlist, res, side, level, p.adj, digits){

	k <- length(t.lab)
	ind <- c(NA, NA, NA)
	
	res0 <- rlist[[1]]
	res1 <- rlist[[2]]
	res2 <- rlist[[3]]

	pos <- (res$beta > 0 )
	neg <- (res$beta < 0 )
	null <- rep(FALSE, k)
	for(i in seq_len(3))
	{
		if(!is.null(rlist[[i]])) ind[i] <- pmatch(snp.var, names((rlist[[i]])$pval))
	}

	if(!is.null(res2))
	{
		if(side == 1)
		{
			pos <- (pos & res2$pheno[ind[3], ])
			neg <- (neg & res2$pheno[ind[3], ])
			null <- (null | !res2$pheno[ind[3], ])
		} else
		{
			pos <- (pos & res2$pheno.1[ind[3], ])
			neg <- (neg & res2$pheno.2[ind[3], ])
			null <- (null | (!res2$pheno.1[ind[3], ] & !res2$pheno.2[ind[3], ]))		
		}
	}
	
	CI <- getCI(res$beta, res$sd, level = level)

	CI.str <- apply(data.matrix(CI), 1, function(x)
					{
					paste("(", round(x[2], digits=digits), ", ", 
	                               round(x[3], digits=digits), ")", sep="")
					})
	
	if(p.adj) res$pval <- pmin(res$pval * k, 1)
	pval.str <- format(res$pval, digits=2, scientific=TRUE)
	pval.str[is.na(res$pval)] <- NA_character_
	
	
					
	nrow <- 1 
	nrow <- nrow + (if(any(neg)) (sum(neg) + 2) else 0) 
	nrow <- nrow + (if(any(null)) (sum(null) + 2) else 0)
	nrow <- nrow + (if(any(pos)) (sum(pos) + 2) else 0)
	nrow <- nrow + 1
	if(!is.null(res0)) nrow <- nrow + 1
	if(!is.null(res1)) nrow <- nrow + 1
	if(!is.null(res2) && side==1) nrow <- nrow + 1
	if(!is.null(res2) && side==2) nrow <- nrow + 3 
	
	
	mdat <- matrix(NA, nrow, 4)
	colnames(mdat) <- c("Mid", "Low", "High", "Pvalue")
	tab <- matrix(as.character(NA), nrow, 7)
	is.summary <- rep(FALSE, nrow)
	is.summary[1] <- TRUE
	colnames(tab) <- c("Phenotype", "OR", "GAP1", "CIstr", "GAP2", "PVALstr", "GAP3")
	tab[, "GAP1"] <- "    "
	tab[, "GAP2"] <- "    "
	tab[, "GAP3"] <- "  "
	
	dir <- list(neg, null, pos)
	names(dir) <- c("Negative", "Null", "Positive")
	cur <- 1
	for(i in seq_len(3))
	{
		clen <- 0
		if(any(dir[[i]]))
		{
			len <- sum(dir[[i]])
			v <- seq_len(len)
			mdat[cur + clen + 2 + v,"Mid"] <- log(CI$mid[dir[[i]]])
			mdat[cur + clen + 2 + v,"Low"] <- log(CI$low[dir[[i]]])
			mdat[cur + clen + 2 + v,"High"] <- log(CI$high[dir[[i]]])
			mdat[cur + clen + 2 + v,"Pvalue"] <- res$pval[dir[[i]]]

			tab[cur + clen + 2,"Phenotype"] <- names(dir)[i]
			tab[cur + clen + 2 + v,"Phenotype"] <- t.lab[dir[[i]]]
			tab[cur + clen + 2 + v,"OR"] <- round(CI$mid[dir[[i]]], digits=digits)
			tab[cur + clen + 2 + v,"CIstr"] <- CI.str[dir[[i]]]
			tab[cur + clen + 2 + v,"PVALstr"] <- pval.str[dir[[i]]]

			is.summary[cur + clen + 2] <- TRUE

			clen <- clen + len + 2
		}
		cur <- cur + clen
	}
	cur <- cur + 1
	
	for(i in seq_len(3))
	{
		res.i <- rlist[[i]]
		if(!is.null(res.i))
		{
			if(i != 3 || side !=2)
			{
				CI.i <- getCI(res.i$beta[snp.var], res.i$sd[snp.var], level = level)
				CI.i.str <- paste("(", round(CI.i[1, 2], digits=digits), ", "
					, round(CI.i[1, 3], digits=digits), ")", sep="")
				pval.i <- res.i$pval[ind[i]]
				pval.i.str <- if(is.na(pval.i)) NA_character_ else format(pval.i, digits=2, scientific=TRUE)

				mdat[cur + 1, "Mid"] <- log(CI.i$mid[1])
				mdat[cur + 1, "Low"] <- log(CI.i$low[1])
				mdat[cur + 1, "High"] <- log(CI.i$high[1])
				mdat[cur + 1, "Pvalue"] <- pval.i

				tab[cur + 1,"Phenotype"] <- names(rlist)[i]
				tab[cur + 1, "OR"] <- round(CI.i$mid[1], digits=digits)
				tab[cur + 1,"CIstr"] <- CI.i.str
				tab[cur + 1,"PVALstr"] <- pval.i.str

				is.summary[cur + 1] <- TRUE

				cur <- cur + 1
			} else
			{
				CI2.1 <- getCI(res.i$beta.1[snp.var], res.i$sd.1[snp.var], level = level)
				CI2.2 <- getCI(res.i$beta.2[snp.var], res.i$sd.2[snp.var], level = level)
				CI2.1.str <- paste("(", round(CI2.1[1, 2], digits=digits), ", ", 
			                        round(CI2.1[1, 3], digits=digits), ")", sep="")
				CI2.2.str <- paste("(", round(CI2.2[1, 2], digits=digits), ", ", 
		                        round(CI2.2[1, 3], digits=digits), ")", sep="")
				pval.i <- res.i$pval[ind[i]]
				pval.i.str <- if(is.na(pval.i)) NA_character_ else format(pval.i, digits=2, scientific=TRUE)
				pval.i.1 <- res.i$pval.1[ind[i]]
				pval.i.2 <- res.i$pval.2[ind[i]]
				pval.i.1.str <- if(is.na(pval.i.1)) NA_character_ else format(pval.i.1, digits=2, scientific=TRUE)
				pval.i.2.str <- if(is.na(pval.i.2)) NA_character_ else format(pval.i.2, digits=2, scientific=TRUE)

				v <- seq_len(3)
				mdat[cur + v, "Mid"] <- log(c(NA, CI2.1$mid[1], CI2.2$mid[1]))
				mdat[cur + v, "Low"] <- log(c(NA, CI2.1$low[1], CI2.2$low[1]))
				mdat[cur + v, "High"] <- log(c(NA, CI2.1$high[1], CI2.2$high[1]))
				mdat[cur + v, "Pvalue"] <- c(res.i$pval[ind[i]], res.i$pval.1[ind[i]], res.i$pval.2[ind[i]])

				tab[cur + v,"Phenotype"] <- c(names(rlist)[3], "    Positive", "    Negative")
				tab[cur + v, "OR"] <- round(c(NA, CI2.1$mid[1], CI2.2$mid[1]), digits=digits)
				tab[cur + v,"CIstr"] <- c(NA, CI2.1.str, CI2.1.str)
				tab[cur + v,"PVALstr"] <- c(pval.i.str, pval.i.1.str, pval.i.2.str)
				
				is.summary[cur + v] <- c(TRUE, TRUE, TRUE)
				
				cur <- cur + 3
			}
		}
	}
	hdr <- c("Phenotype", "OR", "", paste(round(100*(1 - level), digits=1), "% CI", sep="")
			, "", paste("P-value", if(p.adj) "(Adj)" else "(Unadj)"), "")
	tab[1,] <- hdr


#	par(omi = c(1, 0.05, 0.5, 0.05))

	rmeta::forestplot(tab, mdat[, "Mid"], mdat[, "Low"], mdat[, "High"], zero=0, is.summary=is.summary
				, clip=c(log(1/5),log(5)), xlog=TRUE, col=meta.colors(box="royalblue", lines="darkblue", summary="royalblue"))

	title(main=snp.var)
}

# Function to compute the ordinary meta-analysis standard error for estimate of beta based 
# on studies selected as part of s ignoring the randomness of the set s
meta.se <- function(rmat, sigma, subset=NULL) {
  # rmat   Correlation matrix for beta
  # sigma  Vector of standard errors
  
  dim(sigma) <- NULL
  if (!is.null(subset)) {
    sigma <- sigma[subset]
    rmat  <- as.matrix(rmat[subset, subset])
  }
  n          <- length(sigma)
  if (!n) return(NA)
  if (n == 1) {
    temp <- sigma
    dim(temp) <- c(1, 1)
  } else {
    temp      <- diag(sigma)
  }
  COV        <- temp %*% rmat %*% temp
  s2inv      <- 1/(sigma*sigma)
  sum        <- sum(s2inv)
  denom      <- sum*sum
  dim(s2inv) <- c(1, n)
  se <- sqrt((s2inv %*% COV %*% t(s2inv))/denom)
  dim(se) <- NULL
  se

} # END: meta.se

# Top-level function to make a forest plot
h.forestPlot <- function(rlist, snp.var, level=0.05, p.adj=TRUE, digits=2, calc.miss=FALSE) {

  which <- rlist[["which", exact=TRUE]]
  if (which == "h.types") {
    types.forest(rlist, snp.var, level=level, p.adj=p.adj, digits=digits, calc.miss=calc.miss)
  } else if (which == "h.traits") {
    traits.forest(rlist, snp.var, level=level, p.adj=p.adj, digits=digits, calc.miss=calc.miss)
  } else {
    stop("rlist is not a valid return list from h.types() or h.traits()")
  }

  NULL

} # END: h.forest

# Function to check that variables exist in the input data set
checkData.vars <- function(data, vars) {

  if (is.null(vars)) return(NULL)

  cnames <- colnames(data)
  cflag  <- is.character(vars)
  if (cflag) {
    temp <- !(vars %in% cnames)
    if (any(temp)) {
      miss <- vars[temp]
      print(miss)
      emsg <- paste("ERROR: The above variables were not found in the input data")
      stop(emsg) 
    } 
  } else {
    nc <- ncol(data)
    temp <- !(vars %in% seq_len(nc))
    if (any(temp)) {
      miss <- vars[temp]
      print(miss)
      emsg <- paste("ERROR: The above variable positions are not valid")
      stop(emsg) 
    } 
  } 

  NULL

} # END: checkData.vars

# Function to check that variables exist in the input data set
checkData.rownames <- function(data, vars) {

  if (is.null(vars)) return(NULL)
  if (is.null(dim(data))) return(NULL)

  cnames <- rownames(data)
  cflag  <- is.character(vars)
  c2flag <- !is.null(cnames)
  if (cflag && c2flag) {
    temp <- !(vars %in% cnames)
    if (any(temp)) {
      miss <- vars[temp]
      print(miss)
      emsg <- paste("ERROR: The above row names were not found in the input data")
      stop(emsg) 
    } 
  } else {
    nc <- nrow(data)
    temp <- !(vars %in% seq_len(nc))
    if (any(temp)) {
      miss <- vars[temp]
      print(miss)
      emsg <- paste("ERROR: The above row positions are not valid")
      stop(emsg) 
    } 
  } 

  NULL

} # END: checkData.vars

# Function to convert positions to variable names
convertPosToVars <- function(data, pos) {

  if (is.null(pos)) return(NULL)
  if (is.character(pos)) return(pos)

  ret <- colnames(data)[pos]
  ret

} # END: convertPosToVars
 

test_z.max <- function() {

  meta.def <- function(logicalVec, SNP.list, arg.beta, arg.sigma) {
    beta <- as.matrix(arg.beta[SNP.list, logicalVec])
    se   <- as.matrix(arg.sigma[SNP.list, logicalVec])
    test <- (beta/se)^2
    ret  <- apply(test, 1, max)
    list(z=ret) 
  }
  sub.def <- function(logicalVec) {
    sum <- sum(logicalVec)  
    ret <- all(logicalVec[1:sum])
    ret
  }

  k        <- 5
  snp.vars <- 1:3
  nsnp     <- length(snp.vars)
  beta     <- matrix(1:(k*nsnp), nrow=nsnp)
  sigma    <- matrix(rep(1, k*nsnp), nrow=nsnp) 

  meta.args <- list(arg.beta=beta, arg.sigma=sigma)
  
  res1 <- z.max(k, snp.vars, 2, meta.def, meta.args, sub.def=sub.def)

  vec1 <- c(169, 196, 225)

  checkEquals(sum(abs(res1$opt.z - vec1) < 1e-6), nsnp)
 
}

# Nov 01 2011  Pass the subset option in h.types to types.wald
# Nov 03 2011  Allow types.lab to be NULL

h.types <- function(dat, response.var, snp.vars, adj.vars, types.lab, cntl.lab, subset=NULL, method=NULL, side=2
, logit=FALSE, test.type = "Score", zmax.args = NULL, meth.pval = "DLM", pval.args = NULL)

{
    if (!is.data.frame(dat)) stop("dat must be a data frame")
    if ((is.null(side)) || (!(side %in% c(1, 2)))) stop("side must be 1 or 2")
    if ((is.null(meth.pval)) || (!(meth.pval %in% c("DLM", "IS", "B")))) stop("meth.pval must be DLM, IS, or B")
    if ((is.null(logit)) || (!(logit %in% 0:1))) stop("logit must be TRUE or FALSE")
    if ((is.null(test.type)) || (!(test.type %in% c("Score", "Wald")))) stop("test.type must be Score or Wald")
    if (!is.null(pval.args)) {
      if (!is.list(pval.args)) stop("pval.args must be a named list")
      temp <- names(pval.args)
      if (is.null(temp)) stop("pval.args must be a named list")
    }

    # Check that the variables exist
    checkData.vars(dat, response.var)
    checkData.vars(dat, snp.vars)
    checkData.vars(dat, adj.vars)

    # Convert positions to vars
    response.var <- convertPosToVars(dat, response.var)
    snp.vars     <- convertPosToVars(dat, snp.vars)
    adj.vars     <- convertPosToVars(dat, adj.vars)

    if (!is.null(method)) {
      if (length(method) != 1) stop("The method option must be NULL, case.control, or case.complement")
      method <- tolower(method)
      if (method == -1) {
        pool <= -1
      } else {
        temp <- c("case-control", "case-complement") %in% method
        if (!any(temp)) stop("The method option must be NULL, case-control, or case-complement")
        pool <- temp[2]
      }
    } else {
      pool <- NULL
    }
    meth <- test.type
	if(!is.null(subset) && sum(subset) == 0) stop("Empty subset of rows")
	meth.pval <- meth.pval[1]

    # Check cntl.lab, types.lab. 
    if (is.null(subset)) {
      labs <- unique(dat[, response.var])
    } else {
      labs <- unique(dat[subset, response.var])
    }

    if (!(cntl.lab %in% labs)) stop("cntl.lab = ", cntl.lab, " is not a valid label", sep="")
    if (is.null(types.lab)) types.lab <- labs[!(labs %in% cntl.lab)]
    temp      <- !(types.lab %in% cntl.lab)
    types.lab <- types.lab[temp]
    k         <- length(types.lab)
    if (!k) stop("in types.lab. No disease subtypes are being included.")
    temp <- types.lab %in% labs
    if (!all(temp)) {
      temp <- types.lab[!temp]
      print(temp)
      stop("in types.lab. The above disease subtypes are not valid.")
    }
    if (is.null(subset)) {
      subset <- dat[, response.var] %in% c(cntl.lab, types.lab)
    } else {
      subset <- subset & (dat[, response.var] %in% c(cntl.lab, types.lab))
    }
    
	pval.l <- pval1 <- pval2 <- NULL
	par.l <- par1 <- par2 <- NULL
	sigma.l <- sigma1 <- sigma2 <- NULL
	spheno1 <- spheno2 <- NULL
	
	SC <- (is.null(pool) || pool==FALSE)
	CC <- (is.null(pool) || pool==TRUE)

	logit.res <- CC.res <- SC.res <- NULL
	if(logit)
	{ 
		res <- try(types.wald(sub=rep(TRUE, k), snp.vars=snp.vars, dat=dat, response.var=response.var, adj.vars=adj.vars
					, types.lab=types.lab, cntl.lab=cntl.lab, subset=subset, pool=FALSE, side=side))
		if(inherits(res, "try-error")) warning("Failure in Overall Logistic: ", res)
		else logit.res <- res
	}

	if(SC)
	{ 
		if(is.null(pval.args) || is.null(pval.args$search)) pval.args <- c(pval.args, list(search = 0))
		else pval.args$search <- 0

		res <- try(h.types0(k, dat, response.var=response.var, snp.vars=snp.vars, adj.vars=adj.vars, types.lab=types.lab
						, cntl.lab=cntl.lab, subset=subset, pool=FALSE, meth = meth
							, side=side, meta.C = TRUE, zmax.args=zmax.args
							, meth.pval=meth.pval, pval.args=pval.args))
		
		if(inherits(res, "try-error")) warning("Failure in Subset-search (Case-Control): ", res)
		else SC.res <- res
		
	}
	if(CC)
	{ 
		if(is.null(pval.args) || is.null(pval.args$search)) pval.args <- c(pval.args, list(search = 0))
		else pval.args$search <- 0
		
		res <- h.types0(k, dat, response.var=response.var, snp.vars=snp.vars, adj.vars=adj.vars, types.lab=types.lab
						  , cntl.lab=cntl.lab, subset=subset, pool=TRUE, meth = meth
						, side=side, meta.C = TRUE, zmax.args=zmax.args
						, meth.pval=meth.pval, pval.args=pval.args)  

		if(inherits(res, "try-error")) warning("Failure in Subset-search (Case-Control): ", res)
		else CC.res <- res
	}

	#ret <- list(Overall.Logistic = logit.res, Subset.Case.Control = SC.res, Subset.Case.Complement = CC.res)
    ret <- list(Overall.Logistic=logit.res, Subset.Case.Control=SC.res, Subset.Case.Complement=CC.res,
                data=dat, response.var=response.var, adj.vars=adj.vars, types.lab=types.lab,
                cntl.lab=cntl.lab, subset=subset, method=method, side=side, test.type=test.type,
                zmax.args=zmax.args, meth.pval=meth.pval, pval.args=pval.args, logit=logit,
                snp.vars=snp.vars, which="h.types")

	ret
}



h.types0 <- function(k, dat, response.var, snp.vars, adj.vars, types.lab, cntl.lab, pool, meth = "score"
, subset=NULL, side=2, meta.C = FALSE, zmax.args=NULL, meth.pval="DLM", pval.args=NULL)
{
	
	k <- length(types.lab)
	nsnp <- length(snp.vars)
	N <- nrow(dat)
		
	pheno <- NULL

	pval <- rep(NA, nsnp) ; names(pval) <- snp.vars
	par <- pval ; sigma <- pval
	
	
	meta.def <- switch(meth, Score=types.score, Wald=types.wald)
	res <- do.call(z.max, c(list(k=k, snp.vars=snp.vars, side=side, meta.def = meta.def
				, meta.args = list(dat=dat, response.var=response.var, adj.vars = adj.vars
				, types.lab=types.lab, cntl.lab=cntl.lab, subset=subset, pool=pool)), zmax.args))

	zopt <- as.double(res$opt.z)
	pheno <- matrix(as.logical(res$opt.s), ncol=k, byrow=FALSE)
    subsetCount <- res$subsetCount
	
	names(zopt) <- snp.vars
	dimnames(pheno)[[1]] <- as.list(snp.vars)
	dimnames(pheno)[[2]] <- as.list(types.lab)

	
	ncase <- matrix(0, k, nsnp)
	ncntl <- rep(0, nsnp)

	if(is.null(subset)) subset <- rep(TRUE, nrow(dat))
	subset1 <- findMiss.vars(dat, vars=c(response.var, adj.vars), miss = NA)
	subset0 <- if(is.null(subset)) subset1 else (subset & subset1)
	
	for(j in seq_len(nsnp))	
	{
		subset0g <- subset0 & findMiss.vars(dat, vars=snp.vars[j], miss = NA)
		
		tab <- table(dat[subset0g, response.var], useNA = "no")
		pos <- pmatch(c(cntl.lab, types.lab), names(tab), nomatch = 0)

		ncase[, j] <- ifelse(pos[-1] > 0, tab[pos[-1]], 0)
		ncntl[j] <- if(pos[1] > 0) tab[pos[1]] else 0
	}

	if(meth.pval == "DLM")
	{
		if(is.null(pval.args) || !("cor.def" %in% names(pval.args))) pval.args <- c(pval.args, list(cor.def=NULL))
		if(!("cor.args" %in% names(pval.args))) pval.args <- c(pval.args, list(cor.args = list(ncase=ncase, ncntl=ncntl, pool=pool)))
		
		pval <- do.call(p.dlm, c(list(t.vec=abs(zopt), k=k, side = side), pval.args))
	}
		
	if(meth.pval == "IS") pval <- do.call(p.tube, c(list(t.vec=abs(zopt), k=k
									, side = side, ncase=ncase, ncntl=ncntl
									, pool=pool), pval.args))
	
	if(meth.pval == "B") pval <- p.bon(abs(zopt), subsetCount, search = 0, side = side)
	
	names(pval) <- snp.vars
	
	par <- sigma <- NULL

#	Estimate Parameters
	if(TRUE)
	{
		res <- types.wald(sub=pheno, snp.vars=snp.vars, dat=dat, response.var=response.var
							, adj.vars=adj.vars, types.lab=types.lab, cntl.lab=cntl.lab, pool=pool, side = side)
		par <- res$beta
		names(par) <- snp.vars
		if(side == 2) sigma <- abs(par)/qnorm(pval/2, lower.tail=FALSE, log.p=FALSE)
		else sigma <- par/qnorm(pval, lower.tail=FALSE, log.p=FALSE)
	}
	list(pval=pval, beta=par, sd=sigma, zopt = zopt, pheno=pheno)
}

types.score <- function(sub, snp.vars, dat, response.var, adj.vars, types.lab, cntl.lab, subset=NULL, pool=FALSE)
{
	
	sub.case <- types.lab[sub]
	sub.cntl <- if(pool == FALSE) cntl.lab else c(types.lab[!sub], cntl.lab)
	
	nsnp <- length(snp.vars)
	
#	valid row numbers
	subset1 <- dat[, response.var] %in% c(sub.case, sub.cntl)
	subset01 <- if(is.null(subset)) subset1 else subset & subset1
	subset01x <- subset01 & findMiss.vars(dat, vars = c(response.var, adj.vars), miss = NA)
	
	if(is.null(adj.vars)) p <- 1
	else p <- length(adj.vars) + 1
	geno.flag <- (p == 1 && all(dat[, snp.vars] %in% c(0, 1, 2, NA)))

	if(is.null(adj.vars)) adj.vars <- ""
	if(length(adj.vars) > 1) adj.vars <- paste(adj.vars, collapse="+")	
	fmla <- "~1"
	if(adj.vars != "") fmla <- paste(fmla, "+" , adj.vars, sep="")
	xmat <- model.matrix(as.formula(fmla), dat[subset01x, ], na.action="na.pass")
	
	N <- sum(subset01x)
	
	d.vec <- rep(NA, N)
	d.vec[dat[subset01x, response.var] %in% sub.case] <- 1
	d.vec[dat[subset01x, response.var] %in% sub.cntl] <- 0
	
	
	p.vec <- rep(-1, N)
	if(geno.flag) { 
		mat <- matrix(table(d.vec), ncol=2)
		res <- try(glm(mat ~ 1, family=binomial(link="logit")))
	} else res <- try(glm(d.vec ~ xmat, family=binomial(link="logit")))
	
	if(inherits(res, "try-error") || (!res$converged))
	{
		warning("Failure in glm")
		p.vec <- rep(mean(d.vec, na.rm = TRUE), N)
	} else
	{
		if(geno.flag) p.vec <- rep(res$fitted, N)
		else p.vec <- res$fitted
	}
	
	g.vec <- as.vector(data.matrix(dat[subset01x, snp.vars]))
	nmiss.ind <- !(is.na(g.vec))
	 
#	nmiss.ind <- matrix(!tmp, ncol=nsnp)
#	g.vec <- as.vector(g.mat)
	
	xinfo <- t(xmat) %*% ( p.vec * (1 - p.vec) * xmat)
	xcov <- myInv(xinfo)
	
	res <- score.compute(d.vec, p.vec, g.vec, xmat, nmiss.ind, N, nsnp, p, xcov=xcov)
	numr <- res$numr
	denr <- res$denr
	
#	
#	If this flag is set, all SNPs with negative denominator are refit (using 
#	individuals with non-missing genotype).
#	
	REFIT <- FALSE
	if(REFIT && any(denr < 0))
	{
		for(j in which(denr < 0))
		{
			warning("Negative denominator before refitting: ", snp.vars[j])
			g.vec.j <- g.vec[, (j - 1) * N + seq_len(N)]
			nmiss.j <- nmiss.ind[(j - 1) * N + seq_len(N)]
			NN <- sum(nmiss.j)
			p.vec.j <- rep(-1, N)
			if(geno.flag) { 
				mat <- matrix(table(d.vec[nmiss.j]), ncol=2)
				res <- try(glm(mat ~ 1, family=binomial(link="logit")))
			} else res <- try(glm(d.vec ~ xmat, subset = nmiss.j, family=binomial(link="logit")))
			
			if(inherits(res, "try-error") || (!res$converged)) warning("Failure in glm")
			else
			{
				if(geno.flag) p.vec[nmiss.j] <- rep(res$fitted, NN)
				else p.vec[nmiss.j] <- res$fitted
			}
			
			res <- score.compute(d.vec, p.vec.j, g.vec.j, xmat, nmiss.j, N, 1, p, xcov=NULL)
			numr[j] <- res$numr
			denr[j] <- res$denr
			if(denr[j] < 0) warning("Negative denominator after refitting: ", snp.vars[j])
		}
	}
#	print(c(sub))
#	print(rbind(numr, denr))
	
    # Changed July 31, 2013
	#ztmp <- ifelse(is.na(denr) | is.nan(denr) | denr <= 0, 0, numr/sqrt(denr))	
    ztmp <- ifelse(is.na(denr) | is.nan(denr), 0, numr/sqrt(denr))
	list(z = ztmp)
}

score.compute <- function(d.vec, p.vec, g.vec, xmat, nmiss, N, nsnp, p, xcov=NULL)
{
	q.vec <- (1 - p.vec)
	
	tmp.mat <- matrix(g.vec * nmiss * (d.vec - p.vec), N, nsnp, byrow=FALSE)
	numr0 <- apply(tmp.mat, 2, sum, na.rm=TRUE)
	tmp.mat <- matrix(nmiss * g.vec * g.vec * p.vec * q.vec, N, nsnp, byrow=FALSE)
	denr0 <- apply(tmp.mat, 2, sum, na.rm=TRUE)
	
	XtDg <- matrix(vapply(seq_len(p), function(j)
						  {
						  tmp.mat <- matrix(g.vec * nmiss * p.vec * q.vec * xmat[, j], N, nsnp, byrow=FALSE)
						  apply(tmp.mat, 2, sum, na.rm=TRUE)				   
						  }, rep(0, nsnp)), ncol=p, byrow=FALSE)
	XtD <- matrix(vapply(seq_len(p), function(j)
						 {
						 tmp.mat <- matrix(nmiss * (d.vec - p.vec) * xmat[, j], N, nsnp, byrow=FALSE)
						 apply(tmp.mat, 2, sum, na.rm=TRUE)
						 }, rep(0, nsnp)), ncol=p, byrow=FALSE)
	rm(tmp.mat)
	gc()
	
	if(! is.null(xcov))
	{
		numr <- numr0 - vapply(seq_len(nsnp), function(j){ 
							   crossprod(matrix(XtDg[j, ], ncol = 1), xcov %*% matrix(XtD[j, ], ncol=1))
							   }, 0)
		
		denr <- denr0 - apply(XtDg, 1, function(x){ 
							  mx <- matrix(x, ncol=1)
							  crossprod(mx, xcov %*% mx)
							  })
	}
	else
	{
		xinfo <- t(xmat) %*% (nmiss * p.vec * q.vec * xmat)
		numr <- numr0 - vapply(seq_len(nsnp), function(j){ crossprod(matrix(XtDg[j, ], ncol = 1)
				, mySolve(xinfo, matrix(XtD[j, ], ncol=1)))}, 0)
		denr <- denr0 - apply(XtDg, 1, function(x){ mx <- matrix(x, ncol=1) ; crossprod(mx, mySolve(xinfo, mx))})
	}
	return(list(numr=numr, denr=denr))
}

types.wald <- function(sub, snp.vars, dat, response.var, adj.vars, types.lab, cntl.lab, subset=NULL, pool=FALSE, side=2)
{
	nsnp <- length(snp.vars)
	k <- length(types.lab)
	N <- nrow(dat)

	if(length(sub) == (k * nsnp))
	{
		if(k == 1 && is.null(dim(sub))) dim(sub) <- c(nsnp, 1)
		if(nsnp == 1 && is.null(dim(sub))) dim(sub) <- c(1, k)
		if(nrow(sub) != nsnp || ncol(sub) != k) stop("sub should be of dimension nsnp X k")
	}
	if(is.null(dim(sub)) && length(sub) == k) sub <- matrix(sub, nsnp, k, byrow=TRUE)		
	
	sub.case <- types.lab[sub[1, ]]
	sub.cntl <- if(pool == FALSE) cntl.lab else c(types.lab[!sub[1, ]], cntl.lab)
	
	if(is.null(adj.vars)) p <- 1
	else p <- length(adj.vars) + 1
	geno.flag <- (p == 1 && all(dat[, snp.vars] %in% c(0, 1, 2, NA)))
	
	if(is.null(adj.vars)) adj.form <- ""
	if(is.null(snp.vars)) snp.form <- ""
	
  ##SMB: changed this from > 1 to >= 1, since I was getting an error when there
  ##was only one variable that needed adjusting for
	if(length(adj.vars) >= 1) adj.form <- paste(adj.vars, collapse="+")
	##if(length(adj.vars) > 1) adj.form <- paste(adj.vars, collapse="+")
	
	fmla <- paste(response.var, "~ 1", sep="")					 
	if(snp.vars[1] != "") fmla <- paste(fmla, "+" , snp.vars[1], sep="")
	if(adj.form != "") fmla <- paste(fmla, "+" , adj.form, sep="")
	ndat <- model.frame(as.formula(fmla), dat, na.action="na.pass")
	
	dx <- dat[,response.var]
	dx1 <- rep(0, N)
	
	dx1[dx %in% sub.cntl] <- 0
	dx1[dx %in% sub.case] <- 1

	subset1 <- (dx %in% c(sub.cntl, sub.case))
	subset01 <- if(is.null(subset)) subset1 else subset & subset1
	
	dx1[!subset01] <- NA
	
	ndat[, response.var] <- dx1
	ndat[, response.var] <- as.integer(ndat[, response.var])
	
	stat <- vapply(seq_len(nsnp), function(j)
					 {

					if(nrow(sub) == nsnp)
					{
						sub.case <- types.lab[sub[j, ]]
						sub.cntl <- if(pool == FALSE) cntl.lab else c(types.lab[!sub[j, ]], cntl.lab)

						dx1 <- rep(0, N)
						dx1[dx %in% sub.cntl] <- 0
						dx1[dx %in% sub.case] <- 1
						subset1 <- (dx %in% c(sub.cntl, sub.case))
						subset01 <- if(is.null(subset)) subset1 else subset & subset1
						dx1[!subset01] <- NA
						ndat[, response.var] <- dx1
					}
					snp <- snp.vars[j]
					g.vec <- dat[, snp]
					ndat[,2] <- g.vec
					colnames(ndat)[2] <- snp
					 
					fmla <- paste(response.var, "~ 1", sep="")
					if(snp != "") fmla <- paste(fmla, "+" , snp, sep="")
					if(adj.form != "") fmla <- paste(fmla, "+" , adj.vars, sep="")

					
					ret <- c(NA, NA)
					if(geno.flag)
					{
						mat <- table(g.vec, 1 - dx1, useNA="no") ; geno <- (0:2)
						res <- try(glm(mat ~ geno, family=binomial(link="logit")))
					} else res <- try(glm(as.formula(fmla), data=ndat, subset = subset01, family=binomial(link="logit")))

					if(inherits(res, "try-error") || (!res$converged)) warning("Failure in glm")
					else 
					{
						coef <- summary(res)$coef
						pos <- pmatch(if(geno.flag) "geno" else snp, rownames(coef))
						if(!is.na(pos)) ret <- coef[pos, c(1, 2)]
					}
					ret
					}, c(0,0))

	colnames(stat) <- snp.vars

	beta <- stat[1, ]
	names(beta) <- snp.vars
	
	sd <- stat[2, ]
	names(sd) <- snp.vars
	
	z <- ifelse(is.na(sd) | is.nan(sd) | sd <= 0, 0, beta/sd)

	if(side == 2) pval <- 2 * pnorm(abs(beta/sd), lower.tail=FALSE)
	else pval <- pnorm(beta/sd, lower.tail=FALSE)

	list(z=z, beta=beta, sd=sd, pval=pval)
}

types.forest0 <- function(dat, snp.var, response.var, adj.vars, types.lab, cntl.lab, subset=NULL, rlist = NULL
, level = 0.05, p.adj = TRUE, digits = 2)
{
	if(length(snp.var) > 1) stop("Length of snp.var should be 1")
	if(!(snp.var %in% colnames(dat))) stop("colnames of dat does not have snp.var")
	k <- length(types.lab)
	nsub <- matrix(FALSE, k, k)
	diag(nsub) <- TRUE
	
	if(!is.null(rlist))
	{
		if(is.null(rlist$Overall.Logistic)) stop("Missing Component in rlist: Overall.Logistic")
		if(is.null(rlist$Subset.Case.Control)) stop("Missing Component in rlist: Subset.Case.Control")
		if(is.null(rlist$Subset.Case.Complement)) stop("Missing Component in rlist: Subset.Case.Complement")
	} else
	{
		rlist <- h.types(dat=dat, snp.vars=snp.var, response.var=response.var, adj.vars=adj.vars
						 , types.lab=types.lab, cntl.lab=cntl.lab, subset=subset, method = NULL,
                         logit = TRUE, test.type = "Wald")
	}
 	
	res <- types.wald(sub = nsub, snp.vars=rep(snp.var, k), dat=dat, response.var=response.var, adj.vars=adj.vars
					   , types.lab=types.lab, cntl.lab=cntl.lab, subset=subset, pool=FALSE)

	h.forest(k, snp.var, types.lab, rlist, res, side = 1, level=level, p.adj = p.adj, digits=digits)
}

types.forest <- function(rlist, snp.var, level=0.05, p.adj=TRUE, digits=2, calc.miss=FALSE)
{
	if(length(snp.var) > 1) stop("Length of snp.var should be 1")
	if(!(snp.var %in% colnames(rlist$data))) stop("colnames of data does not have snp.var")
    if (!(snp.var %in% rlist$snp.vars)) stop("snp.var was not a SNP analyzed")

    types.lab    <- rlist$types.lab
    cntl.lab     <- rlist$cntl.lab
    response.var <- rlist$response.var
    adj.vars     <- rlist$adj.vars
    subset       <- rlist$subset
    method       <- rlist$method
    side         <- rlist$side
    test.type    <- rlist$test.type
    zmax.args    <- rlist$zmax.args
    meth.pval    <- rlist$meth.pval
    pval.args    <- rlist$pval.args 

	k <- length(types.lab)
	nsub <- matrix(FALSE, k, k)
	diag(nsub) <- TRUE
	
    ov      <- rlist[["Overall.Logistic", exact=TRUE]]
    cc      <- rlist[["Subset.Case.Control", exact=TRUE]]
    cp      <- rlist[["Subset.Case.Complement", exact=TRUE]]
    ov.flag <- !is.null(ov)
    cc.flag <- !is.null(cc)
    cp.flag <- !is.null(cp)
    if (calc.miss && ((!ov.flag) || (!cc.flag) || (!cp.flag))) 
    {
      if (ov.flag) 
      {
        logit <- FALSE
      } else 
      {
        logit <- TRUE
      }

      method <- "-1"
      if ((!cc.flag) && (!cp.flag)) 
      {
        method <- NULL
      } else if (!cc.flag) 
      {
        method <- "case-control"
      } else if (!cp.flag) 
      {
        method <- "case-complement"
      }

      ret <- h.types(rlist$data, response.var, snp.var, adj.vars, types.lab, cntl.lab, subset=subset,
              method=method, side=side, logit=logit, test.type=test.type, zmax.args=zmax.args, 
              meth.pval=meth.pval, pval.args=pval.args)
      if (!ov.flag) ov <- ret[["Overall.Logistic", exact=TRUE]]
      if (!cc.flag) cc <- ret[["Subset.Case.Control", exact=TRUE]]
      if (!cp.flag) cp <- ret[["Subset.Case.Complement", exact=TRUE]]
    }
    
    newlist <- list(Overall.Logistic=ov, Subset.Case.Control=cc, Subset.Case.Complement=cp)
    
    res <- types.wald(sub = nsub, snp.vars=rep(snp.var, k), dat=rlist$data, response.var=response.var, 
               adj.vars=adj.vars, types.lab=types.lab, cntl.lab=cntl.lab, subset=subset, pool=FALSE)

    h.forest(k, snp.var, types.lab, newlist, res, side = 1, level=level, p.adj = p.adj, digits=digits)
}

test_h.types <- function() {
 
  data(ex_types, package="ASSET")
  snps     <- "SNP_1"
  adj.vars <- c("CENTER_1", "CENTER_2", "CENTER_3")
  types    <- paste("SUBTYPE_", 1:5, sep="")
  res      <- h.types(data, "TYPE", snps, adj.vars, types, "SUBTYPE_0", subset=NULL, 
        method="case-control", side=2, logit=TRUE, test.type="Score", 
        zmax.args=NULL, meth.pval="DLM", pval.args=NULL)

  lvec1 <- c(TRUE, FALSE, FALSE, FALSE, FALSE)

  checkEqualsNumeric(res$Overall.Logistic$pval, 0.003239651, tolerance=1.0e-6)
  checkEqualsNumeric(res$Subset.Case.Control$pval, 1.223364e-05, tolerance=1.0e-6)
  checkEquals(sum(res$Subset.Case.Control$pheno == lvec1), 5)

}

%\VignetteIndexEntry{ASSET Vignette}
%\VignetteEngine{knitr::knitr}
%\VignettePackage{ASSET}
%\VigetteDepends{ASSET}


\documentclass[a4paper]{article}


\begin{document}

\title{ASSET(Association analysis for SubSETs) Package}
\maketitle

\section*{Introduction}
ASSET is a suite of statistical tools specifically designed to be powerful for pooling association signals across multiple studies when true effects may exist only in a subset of the studies and could be in opposite directions across studies. The method explores all possible subsets (or a restricted set if user specifies so) of studies and evaluates fixed-effect meta-analysis-type test-statistics for each subset. The final test-statistic is obtained by maximizing the subset-specific test-statistics over all possible subsets and then evaluating its significance after efficient adjustment for multiple-testing, taking into account the correlation between test-statistics across different subsets due to overlapping subjects. The method not only returns a p-value for significance for the overall evidence of association of a SNP across studies, but also outputs the "best subset" containing the studies that contributed to the overall association signal. For detection of association signals with effects in opposite directions, ASSET allows subset search separately for positively- and negatively- associated studies and then combines association signals from two directions using a chi-square test-statistic. The method can take into account correlation due to overlapping subjects across studies (e.g. shared controls). Although the method is originally developed for conducting genetic association scans, it can also be applied for analysis of non-genetic risk factors as well.

The ASSET package consists of two main functions: (1) h.traits and (2) h.types. The function h.traits
is suitable for conducting meta-analysis of possibly different traits when summary level data are available from individual
studies. The function allows for correlation among different studies/traits, which, for example, may arise due to shared subjects across studies.
This function can also be used to conduct "meta-analysis" across multiple correlated traits on the same individuals by appropriately specifying the correlation
matrix for the multivariate trait. Input arguments to this function are vectors/matrices of the estimated log-odds ratios, standard errors and
number of cases and controls for each SNP and study. 
The function h.types is suitable for analysis of case-control studies when cases consist of distinct disease subtypes. This
function assumes individual level data are available. The main input argument for h.types is a data frame containing the SNP variables,
response variable and covariates for all subjects.


<<start>>=
library(ASSET)
@

\section*{Examples of h.traits}

Get the path to the data.
<<data file>>=
datafile <- system.file("sampleData", "vdata.rda", package="ASSET")
@


Load the data frames. There are 4 data frames, data1 - data4 for the 4 independent studies.
Each study has the SNPs SNP1-SNP3 genotyped, and information on each subject's age and
case-control status.
Each SNP is coded as the number of copies of the minor allele or NA for missing genotypes.
<<load data>>=
load(datafile)
data1[1:5, ]

SNPs    <- paste("SNP", 1:3, sep="")
nSNP    <- length(SNPs)
studies <- paste("STUDY", 1:4, sep="") 
nStudy  <- length(studies)
@

Let us determine the number of non-missing cases and controls for each SNP and study.
<<ncase ncontrol>>=
case    <- matrix(data=NA, nrow=nSNP, ncol=nStudy) 
control <- matrix(data=NA, nrow=nSNP, ncol=nStudy) 

for (i in 1:nStudy) {
  data <- eval(parse(text=paste("data", i, sep="")))
  caseVec <- data[, "CC"] == 1
  controlVec <- !caseVec
  for (j in 1:nSNP) {
    temp <- !is.na(data[, SNPs[j]])
    case[j, i] <- sum(caseVec & temp, na.rm=TRUE)
    control[j, i] <- sum(controlVec & temp, na.rm=TRUE)
  }
}
case
control
@

Run a logistic regression for each SNP and study
<<log reg>>=
beta  <- matrix(data=NA, nrow=nSNP, ncol=nStudy) 
sigma <- matrix(data=NA, nrow=nSNP, ncol=nStudy) 
for (i in 1:nStudy) {
  data <- eval(parse(text=paste("data", i, sep="")))
  for (j in 1:nSNP) {
    data[, "SNP"] <- data[, SNPs[j]]
    fit <- glm(CC ~ AGE + SNP, data=data, family=binomial())
    coef <- summary(fit)$coefficients
    beta[j, i] <- coef["SNP", 1]
    sigma[j, i] <- coef["SNP", 2]
  }
}
beta
sigma

@

Call the h.traits function. Since the studies are independent, we do not need to specify the
cor option.
<<h.traits>>=
res <- h.traits(SNPs, studies, beta, sigma, case, control, meta=TRUE)
@

Compute a summary table. Notice that in the Subset.2sided results, the first 2 SNPs have missing
values for OR.2, CI.low.2, and CI.high.2 since the estimated betas were all positive for these SNPs.
<<summary table>>=
h.summary(res)
@

Intead of searching over all possible subsets, let us define our own subset function
to determine which nsubsets to search over. We will only consider subsets where the first m
traits are in the subset (m = 1, 2, ...). The DLM p-value will also be computed using only
these subsets.
<<subset function>>=
sub.def <- function(logicalVec) {
  sum <- sum(logicalVec)  
  ret <- all(logicalVec[1:sum])
  ret
}
@

Call the h.traits function with the zmax.args pval.args options defined
<<h.traits 2>>=
res <- h.traits(SNPs, studies, beta, sigma, case, control, meta=TRUE, 
         zmax.args=list(sub.def=sub.def), pval.args=list(sub.def=sub.def))
@

<<summary table 2>>=
h.summary(res)
@

\section*{Examples of h.types}

The disease subtype variable in each study data frame is called TYPE, which has
values "TYPE\_1", "TYPE\_2", "TYPE\_3" and "CONTROL".
First, we will combine the individual study data into a single data frame
<<combine data>>=
data <- NULL
for (i in 1:nStudy) {
  temp <- eval(parse(text=paste("data", i, sep="")))
  temp[, "STUDY"]  <- i
  data <- rbind(data, temp)
}
@

In addition to age, we will also adjust for study. 
Create the study indicator variables:
<<dummy vars>>=
for (i in 1:nStudy) {
  dvar <- paste("STUDY_", i, sep="")
  data[, dvar] <- as.numeric(data[, "STUDY"] %in% i)
}
@

Define the SNP variables, adjustment variables and disease subtype labels.
<<variables>>=
snp.vars <- paste("SNP", 1:3, sep="")
adj.vars <- c("AGE", "STUDY_1", "STUDY_2", "STUDY_3")
types.lab <- paste("TYPE_", 1:3, sep="")
@

Call the h.types function with option logit=TRUE to also run the overall 
logistic regression for each SNP.
<<h.types>>=
ret <- h.types(data, "TYPE", snp.vars, adj.vars, types.lab, "CONTROL",
               logit=TRUE)
@

Summarize the results
<<h.types summary>>=
h.summary(ret)
@


\section*{Session Information}
<<sessionInfo>>=
sessionInfo()
@ 

\end{document}

% --- Source file: man/h.types.Rd ---
\name{h.types}
\alias{h.types}
\title{Heterogeneous Subtype analysis}
\description{
Subset-based analysis of case-control studies with heterogeneous disease subtypes.
}
\usage{
h.types(dat, response.var, snp.vars, adj.vars, types.lab, cntl.lab, 
        subset=NULL, method=NULL, side=2, logit=FALSE, test.type="Score", 
        zmax.args=NULL, meth.pval="DLM", pval.args=NULL)
}
\arguments{
  \item{dat}{A data frame containing individual level data for phenotype (disease status/subtype information), covariate data and
   SNPs. No default.}
  \item{response.var}{Variable name or position of the response variable column in the data frame.  
        This variable needs to contain disease status/subtype information in the data frame. No default.}
\item{snp.vars}{A character or numeric vector giving the variable names or positions of the SNP variables. Missing values for SNP genotypes are indicated by NA. No default.}
 \item{adj.vars}{A character or numeric vector containing the variable names or positions of the columns in the data frame that would be used as adjusting covariates in the analysis. 
   Use NULL if no covariates are used for adjustment.}
\item{types.lab}{NULL or a character vector giving the names/identifiers of the disease subtypes in \code{response.var} to be
                 included in the analysis. If NULL, then all subtypes will be included. No default.}
\item{cntl.lab}{A single character string giving the name/identifier of controls (disease-free subjects) in \code{response.var}. No default.}
  \item{subset}{A logical vector with length=nrow(\code{dat}) indicating the subset of rows of the data frame to be included in the analysis. Default is NULL, all rows are used.}
  \item{method}{A single character string indicating the choice of method as "case-control" or "case-complement".  
  The Default option is NULL which will carry out both types of analysis. For the case-complement analysis of disease subtype \code{i}, 
  the set of control subjects is formed by taking the complement of disease subtype \code{i}, ie the original controls and the cases
  not defined by disease subtype \code{i}.}
  \item{side}{A numeric value of either 1 or 2 indicating whether one or two-tailed p-values should be computed, respectively. The default is 2.}
  \item{logit}{If TRUE, results are returned from an overall case-control analysis using standard logistic regression. Default is FALSE.}
  \item{test.type}{A character string indicating the type of tests to be performed. The current options are "Score" and "Wald". The default is "Score."}
 \item{zmax.args}{Optional arguments to be passed to \code{\link{z.max}} as a named list. This option can be useful if the user wants to
   restrict subset searches in some structured way, for example, incorporating ordering constraints.}
\item{meth.pval}{A character string indicating the method of evaluating the p-value. Currently the options are "DLM" (Discrete Local
  Maximum), "IS" (Exact Importance Sampling) and "B" (Bonferroni) with the default option being DLM. The IS method is currently computationally
feasible for analysis of at most k=10 studies/traits}
 \item{pval.args}{Optional arguments to be passed to internal p-value calculation functions \code{\link{p.dlm}} (method "DLM") or \code{p.tube} (method "IS") as a named list. This option can be useful if the user wants to
restrict subset searches in some structured way, for example, incorporating ordering constraints.}
}
\value{
   A list containing 3 component lists named:
    
   (1) "Overall.Logistic" (output for overall case-control analysis using standard logistic regression): 
	   This list is non-null when \code{logit} is TRUE and contains 3 vectors named (pval, beta, sd) of length same as snp.vars.
   
   (2) "Subset.Case.Control" (output for subset-based case-control analysis):
	   This list is non-null when \code{method} is NULL or "case-control". The output contains, 3 vectors named (pval, beta, sd) of length same as snp.vars 
	   and a logical matrix named "pheno" with one row for each snp and one column for each disease subtype. For a particular SNP and disease-subtype, the
	   corresponding entry is "TRUE" if that disease subtype is included the best subset of disease subtypes that is identified to be associated with
the SNP in the subset-based case-control analysis. In the output, the p-value is automatically adjusted for multiple testing 
           due to subset search. The beta and sd corresponds to estimate of log-odds-ratio and standard error for a SNP from a logistic regression analysis involving
the cases of the identified disease subtypes and the controls.  

   (3) "Subset.Case.Complement" (output for subset-based case-complement analysis):
       This list is non-null when \code{method} is NULL or "case-complement". The output contains, 3 vectors named (pval, beta, sd) of length same as snp.vars 
	   and a logical matrix named "pheno" with one row for each snp and one column for each disease subtype. For a particular SNP and disease-subtype,  the
	   corresponding entry is "TRUE" if that disease subtype is included the best subset of disease subtypes that is identified to be associated with
the SNP in the subset-based case-complement analysis. In the output, the p-value is automatically adjusted for multiple testing 
           due to subset search. The beta and sd corresponds to estimate of log-odds-ratio and standard error for the SNP from a logistic regression analysis involving
the cases of the selected disease subtypes and the whole complement set of subjects that includes original controls and the cases of unselected disease subtypes. 
}
\details{
The output standard errors are approximate (based on inverting DLM pvalues) and are used for constructing confidence intervals 
in \code{\link{h.summary}} and \code{\link{h.forestPlot}}. For a particular SNP, if any of the genotypes are missing, then those
subjects will be removed from the analysis for that SNP.
}

\seealso{ \code{\link{h.summary}}, \code{\link{h.forestPlot}} }

\examples{
 # Use the example data
 data(ex_types, package="ASSET")

 # Display the first 10 rows of the data and a table of the subtypes
 data[1:10, ]
 table(data[, "TYPE"])
 
 # Define the input arguments to h.types. 
 snps     <- paste("SNP_", 1:3, sep="")
 adj.vars <- c("CENTER_1", "CENTER_2", "CENTER_3")
 types <- paste("SUBTYPE_", 1:5, sep="")

 # SUBTYPE_0 will denote the controls
 res <- h.types(data, "TYPE", snps, adj.vars, types, "SUBTYPE_0", subset=NULL, 
        method="case-control", side=2, logit=FALSE, test.type="Score", 
        zmax.args=NULL, meth.pval="DLM", pval.args=NULL)

 
 h.summary(res)

}

\references{Samsiddhi Bhattacharjee, Preetha Rajaraman, Kevin B. Jacobs, William A. Wheeler, Beatrice S. Melin, Patricia  Hartge, GliomaScan Consortium, Meredith Yeager, Charles C. Chung, Stephen J. Chanock, Nilanjan Chatterjee. A subset-based  approach improves power and interpretation for combined-analysis of genetic association studies of heterogeneous traits. Am  J Hum Genet, 2012, 90(5):821-35 \cr
}

% --- Source file: ex_types.Rd ---
\name{ex_types}
\alias{ex_types}
%\alias{N00}
%\alias{N01}
%\alias{N10}
%\alias{N11}

%\docType{package}
\title{
  Data for the h.types example
}
\description{
 Sample data for \code{\link{h.types}}
}
\details{ The data frame contains columns for disease subtype, study center, and 3 SNPs.
}
\examples{

 data(ex_types, package="ASSET")

 # Display the first 10 rows of the data
 data[1:10, ]

}
\keyword{data}
\seealso{h.traits, fast_asset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fastASSET.R
\name{fast_asset}
\alias{fast_asset}
\title{Fast ASSET using pre-screening}
\usage{
fast_asset(
  snp,
  traits.lab,
  beta.hat,
  sigma.hat,
  Neff,
  cor,
  block,
  scr_pthr = 0.05
)
}
\arguments{
\item{snp}{A character string giving the SNP name to be analyzed. No default.}

\item{traits.lab}{A character vector giving the names/identifiers of the k studies/traits being analyzed. The order of this vector must match the columns of beta.hat and sigma.hat No default.}

\item{beta.hat}{A numeric vector of length k giving the coefficients obtained from the analysis of that SNP across the k studies/traits. No default.}

\item{sigma.hat}{A vector of same dimension as beta.hat, giving the corresponding standard errors. No default.}

\item{Neff}{A numeric vector of same dimension as beta.hat, giving the effective sample size of each study. For continuous traits, the effective sample size is the total sample size; for binary traits, the effective sample size is Ncase*Ncontrol/(Ncase+Ncontrol).}

\item{cor}{A matrix of dimension k by k storing the correlation of z-statistics under the null hypothesis. It can be estimated using LD score regression (https://github.com/bulik/ldsc). For example, element \code{(j,k)} is the LD score regression intercept between traits \code{j} and {k}. Diagonal elements are equal to 1. Set to identity matrix if different studies do not have overlapping samples.}

\item{block}{A list of character vectors. Each element is a vector of study/trait names that fall into the same correlation block based on \code{cor}. Studies from different blocks are treated as independent. Studies that are not in \code{block} are treated as independent from other studies.}

\item{scr_pthr}{P-value threshold for pre-screening. Only traits with p-value < scr_pthr are retained. Default to 0.05.}
}
\value{
A list of the same format as the output of \code{h.traits}.
}
\description{
This function implements a fast version of ASSET for analysis of a large number of traits. It accelerates the computation by restricting subset search among the traits with suggestive level of associations. The traits are selected by a liberal p-value threshold. The input is GWAS summary statistics for one SNP. See details for more information.
}
\details{
The standard ASSET (\code{h.traits}) which searches through all subsets can be computationally intractable for analyzing a large number of traits. \code{fast_asset} reduces the computational burden by the following procedure: (1) De-correlate the z-statistics associated with different traits using the correlation matrix (\code{cor}); (2) select the set of traits using a liberal threshold (p<0.05 by default) of the de-correlated z-statistics; (3) adjust the de-correlated z-statistics for the pre-selection independently across different traits; (4) re-introduce the correlation using the matrix \code{cor} and supply the adjusted statistics to standard ASSET.
}
\examples{
data("ex_fast_asset", package="ASSET")
block <- create_blocks(ldscintmat)
test <- fast_asset(snp=SNP, traits.lab=traits, beta.hat=betahat, sigma.hat=SE
                , Neff=Neff, cor=ldscintmat, block=block, scr_pthr=0.05)
}
\references{
Guanghao Qi, Surya Chhetri, Elizaveta Naydanova, Debashree Ray, Diptavo Dutta, Alexis Battle, Samsiddhi Bhattacharjee and Nilanjan Chatterjee. "Genome-wide Multi-trait Analysis Across 116 Studies Identifies Complex Patterns of Pleiotropy and Unique Trait-Specific Loci". In preparation (2021).
}

% --- Source file: man/h.summary.Rd ---
\name{h.summary}
\alias{h.summary}
\title{Summary results from subset-search.}
\description{
This function produces summary results from subset-based association analysis.
}
\usage{
h.summary(rlist, level = 0.05, digits = 3)
}
\arguments{
  \item{rlist}{List returned by \code{\link{h.traits}} or \code{\link{h.types}} }
  \item{level}{Level for confidence intervals. Default is \code{0.05} for \code{95\%} confidence intervals. The confidence intervals are obtained by inverting the 
corresponding multiple-testing adjusted p-values.}
  \item{digits}{Number of significant digits to retain in odds ratios and confidence intervals in the summary table}
}
\value{
A list of data frames, one for each of the methods specified the original call of the functions \code{\link{h.traits}} or \code{\link{h.types}}. Each row of a data frame corresponds to a SNP and 
the values include p-values for overall association (including component-wise p-values for two-sided search), names of phenotypes or disease subtypes included in
the best-subset, summary regression coefficients (e.g. log-odds-ratio for case-control studies) representing strength of association of a SNP with the
identified subset of traits/subtype  and corresponding confidence intervals.
}
\details{ 
Returns a list of data frames containing p-values, odds-ratios, confidence intervals and the traits/types for each analysis. 
The number of data frames in the list will depend on which function (\code{\link{h.traits}} or \code{\link{h.types}})
was called and on the function options specified. 
}
\seealso{\code{\link{h.forestPlot}}, \code{\link{h.traits}}, \code{\link{h.types}} }

\examples{
 # Use the example data
 data(ex_trait, package="ASSET")

 # Define the input arguments to h.traits
 snps       <- as.vector(data[, "SNP"])
 traits.lab <- paste("Trait_", 1:6, sep="")
 beta.hat   <- as.matrix(data[, paste(traits.lab, ".Beta", sep="")])
 sigma.hat  <- as.matrix(data[, paste(traits.lab, ".SE", sep="")])
 cor        <- list(N11=N11, N00=N00, N10=N10)
 ncase      <- diag(N11)
 ncntl      <- diag(N00)

 # Now let us call h.traits on these summary data. 
 res <- h.traits(snps, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor=cor, 
                 cor.numr=FALSE, search=NULL, side=2, meta=TRUE, 
                 zmax.args=NULL, meth.pval="DLM")
 
 h.summary(res)

}

% --- Source file: ASSET.Rd ---
\name{ASSET}
\alias{ASSET}
\docType{package}
\title{
Association analysis for SubSETs
}
\description{
ASSET is a suite of statistical tools specifically designed to be powerful for pooling association signals across multiple studies when true effects may exist only in a subset of the studies and could be in opposite directions across studies. The method explores all possible subsets (or a restricted set if user specifies so) of studies and evaluates fixed-effect meta-analysis-type test-statistics for each subset. The final test-statistic is obtained by maximizing the subset-specific test-statistics over all possible subsets and then evaluating its significance after efficient adjustment for multiple-testing, taking into account the correlation between test-statistics across different subsets due to overlapping subjects. The method not only returns a p-value for significance for the overall evidence of association of a SNP across studies, but also outputs the "best subset" containing the studies that contributed to the overall association signal. For detection of association signals with effects in opposite directions, ASSET allows subset search separately for positively- and negatively- associated studies and then combines association signals from two directions using a chi-square test-statistic. The method can take into account correlation due to overlapping subjects across studies (e.g. shared controls). Although the method is originally developed for conducting genetic association scans, it can also be applied for analysis of non-genetic risk factors as well.
}
\details{
The package consists of two main functions: (1) \code{\link{h.traits}} and (2) \code{\link{h.types}}. The function \code{\link{h.traits}}
is suitable for conducting meta-analysis of studies of possibly different traits when summary level data are available from individual
studies. The function allows correlation among different studies/traits, which, for example, may arise due to shared subjects across studies.
The function can also be used to conduct "meta-analysis" across multiple correlated traits on the same individuals by appropriately specifying the correlation
matrix for the multivariate trait. The method, however, is not optimized yet (from a power perspective) for analyzing multivariate traits measured on the same 
individuals. The function \code{\link{h.types}} is suitable for analysis of case-control studies when cases consist of distinct disease subtypes. This
function assumes individual level data are available. 
The functions \code{\link{h.summary}} and \code{\link{h.forestPlot}} are useful for summarizing results and displaying forest plots. 
The helper functions
\code{\link{z.max}} and \code{\link{p.dlm}} are generic functions called internally for obtaining the maximized subset-based test-statistics and the corresponding
p-values approximated by the Discrete Local Maximization (DLM) method. These functions can be further customized for specific applications. 
For example, the default options of these functions currently assume all possible subsets to search. For analysis of case-control studies with ordered 
diseased subtypes (e.g. stages of a cancer), however, it may be more meaningful to restrict the subset search to incorporate ordering 
constraints among the disease subtypes. In such a situation, one can pass a function argument \code{sub.def} to \code{z.max} and \code{p.dlm} for performing restricted
subset searches.
}
\author{Samsiddhi Bhattacharjee, Nilanjan Chatterjee and William Wheeler <wheelerb@imsweb.com>}
\keyword{package}
\references{Samsiddhi Bhattacharjee, Preetha Rajaraman, Kevin B. Jacobs, William A. Wheeler, Beatrice S. Melin, Patricia Hartge, GliomaScan Consortium, Meredith Yeager, Charles C. Chung, Stephen J. Chanock, Nilanjan Chatterjee. A subset-based approach improves power and interpretation for combined-analysis of genetic association studies of heterogeneous traits. Am J Hum Genet, 2012, 90(5):821-35 \cr
}

% --- Source file: man/h.forestPlot.Rd ---
\name{h.forestPlot}
\alias{h.forestPlot}
\title{Forest plot for meta-analysis of heterogenerous traits or types.}
\description{
Forest Plot for meta-analysis of heterogenerous traits or types.
}
\usage{
h.forestPlot(rlist, snp.var, level=0.05, p.adj=TRUE, digits=2, calc.miss=FALSE)
}
\arguments{
  \item{rlist}{The list of results returned by \code{\link{h.traits}} or \code{\link{h.types}}. SNPs other than \code{snp.var} are ignored.} 
  \item{snp.var}{A character string giving the name of the SNP variable to be plotted. No default.}
  \item{level}{Level for confidence intervals. Default is \code{0.05} for \code{95\%} confidence intervals.}
  \item{p.adj}{Logical. Whether to report Bonferroni adjusted p-values for each individual subtype. Default is TRUE.}  
  \item{digits}{Number of significant digits to display the odds ratios in the plot.}
  \item{calc.miss}{Logical. If TRUE, first 3 components of rlist are calculated and filled (if NULL) so that all 3 summarizations can be 
        shown in the forest plot.}
}
\value{
Forest plot for a SNP showing regression coefficients (e.g. log-odds-ratio for case-control studies) for individual studies/traits and 
confidence intervals, estimate of an overall regression coefficient and confidence interval based on standard fixed-effect meta-analysis
and estimate of regression coefficient(s) and confidence intervals associated with the identified best subset(s).
}
\seealso{\code{\link{h.summary}}, \code{\link{h.traits}}, \code{\link{h.types}}}

\examples{
 # Use the example data
 data(ex_trait, package="ASSET")
 data

 # Define the input arguments to h.traits
 snps       <- as.vector(data[, "SNP"])
 traits.lab <- paste("Trait_", 1:6, sep="")
 beta.hat   <- as.matrix(data[, paste(traits.lab, ".Beta", sep="")])
 sigma.hat  <- as.matrix(data[, paste(traits.lab, ".SE", sep="")])
 cor        <- list(N11=N11, N00=N00, N10=N10)
 ncase      <- diag(N11)
 ncntl      <- diag(N00)

 # Now let us call h.traits on these summary data. 
 res <- h.traits(snps, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor=cor, 
                 cor.numr=FALSE, search=NULL, side=2, meta=TRUE, zmax.args=NULL, 
                 meth.pval="DLM")

 h.forestPlot(res, "SNP_1", digits=3)

}

% --- Source file: man/h.traits.Rd ---
\name{h.traits}
\alias{h.traits}
\title{Heterogeneous traits or studies}
\description{
Performs one-sided or two-sided subset-based meta-analysis of  heteregeneous studies/traits.
}
\usage{
h.traits(snp.vars, traits.lab, beta.hat, sigma.hat, ncase, ncntl, 
  cor=NULL, cor.numr=FALSE, search=NULL, side=2, meta=FALSE, 
  zmax.args=NULL, meth.pval="DLM", pval.args=NULL)
}
\arguments{
  \item{snp.vars}{A character vector giving the SNP names to be analyzed. No default.}
  \item{traits.lab}{A character vector giving the names/identifiers of the \code{k} studies/traits being analyzed.
        The order of this vector must match the columns of \code{beta.hat} and \code{sigma.hat} No default.}
  \item{beta.hat}{A matrix of dimension length(\code{snp.vars}) by (\code{k}) (or a vector of length \code{k} when 1 SNP is passed). Each row gives the coefficients obtained
  from the analysis of that SNP across the \code{k} studies/traits. No default.}
  \item{sigma.hat}{A vector or matrix of same dimension as beta.hat, giving the corresponding standard errors. No default.}
  \item{ncase}{The number of cases in each of the \code{k} studies. This can be same for each SNP, in which case \code{ncase} is a vector of length \code{k}.
  Alternatively if the number of non-missing cases analyzed for each SNP is known, \code{ncase} can be a length(\code{snp.vars}) by (\code{k}) matrix. No default.}
  \item{ncntl}{Same as \code{ncase} (above) for controls. No default.}
  \item{cor}{Either a \code{k} by \code{k} matrix of inter-study correlations or a list containing three case/control overlap matrices (for
case-control studies)
  named \code{N11}, \code{N00} and \code{N10}. See details. Default is NULL, so that studies are assumed to be independent.
The rows and columns of all matrices  needs to be in the same order as \code{traits.lab} and columns 
of \code{beta.hat} and \code{sigma.hat} }
  \item{cor.numr}{Logical. When specified as TRUE the correlation information is used for optimal weighting of the studies in the definition of the meta-analysis test-statistics. 
The default is FALSE. In either case, the correlation is accounted for variance calculation of the meta-analysis test-statistic.}
  \item{search}{1, 2 or NULL. Search option 1 and 2 indicate one-sided and two-sided subset-searches respectively. The default option is NULL that
automatically returns both one-sided and two-sided subset searches. 
  Default is NULL.}
  \item{side}{Either 1 or 2. For two-tailed tests (where absolute values of Z-scores are maximized), \code{side} should be 2. For one-tailed tests, 
  \code{side} should be 1 (positive tail is assumed). Default is 2. The option is ignored when search=2 since the two-sided subset search is automatically a two-sided
test.}
  \item{meta}{Logical. When specified as TRUE, standard fixed effect meta-analysis results are returned together with results from subset-based meta-analysis. 
The Default is FALSE.}
  \item{zmax.args}{Optional arguments to be passed to \code{\link{z.max}} as a named list. This option can be useful if the user wants to
restrict subset searches in some structured way, for example, incorporating some ordering constraints.}
 \item{pval.args}{Optional arguments  to be passed to internal p-value calculation functions \code{\link{p.dlm}} (method "DLM") or \code{p.tube} (method "IS") as a named list. This option can be useful if the user wants to
restrict subset searches in some structured way, for example, incorporating some ordering constraints.}
 \item{meth.pval}{The method of p-value computation. Currently the options are DLM (Discrete Local
  Maximum), IS(Exact Importance Sampling) and B (Bonferroni) with the default option being DLM. The IS method is currently computationally
feasible for analysis of at most k=10 studies/traits}
}
\value{
   A list containing 3 main component lists named:
    
   (1) "Meta" (Results from standard fixed effect meta-analysis of all  studies/traits). 
	   This list is non-null when \code{meta} is TRUE and contains 3 vectors named (pval, beta, sd) of length same as snp.vars.
   
   (2) "Subset.1sided" (one-sided subset search):
	   This list is non-null when \code{search} is NULL or 1 and contains, 4 vectors named (pval, beta, sd, sd.meta) of length same as snp.vars 
	   and a logical matrix named "pheno" with one row for each snp and one column for each phenotype. For a particular SNP and phenotype, the entry
	   has "TRUE" if this phenotype was in the selected subset for that SNP. In the output, the p-value is automatically adjusted for multiple testing 
           due to subset search. The beta  and sd correspond to the standard fixed-effect meta-analysis estimate and corresponding standard error estimate 
for the regression coefficient of a SNP based only on those studies/traits that are included in the identified subset.
The vector sd.meta gives the meta-analysis standard errors for estimates of beta based on studies in the identified subset ignoring the randomness of the subset.


	   
   (3) Subset.2sided (two-sided subset search)
       This list is non-null when \code{search} is NULL or 2 and contains 9 vectors named 
  (pval, pval.1, pval.2, beta.1, sd.1, beta.2, sd.2, sd.1.meta, sd.2.meta) of length
	   same as snp.vars and two matrices named "pheno.1" and "pheno.2" giving logical indicators of a phenotype being among the positively or negatively
	   associated subsets (respectively) as identified by 2-sided subset search. In the output, while pval provides the significance of the overall test-statistics that
combined association signals from two directions, pval.1 and and pval.2 return the corresponding level of significance for each of the component one-sided
test-statistics in the positive and negative directions.  The values (beta.1, sd.1, beta.2, sd.2) denote the corresponding meta-analysis estimate of regression coefficients
and standard errors for the identifed subsets of traits/studies that show association in positive and negative directions, respectively.
The vector sd.1.meta and sd.2.meta give the meta-analysis standard errors for estimates of beta based on studies in the identified subset ignoring the randomness of the subset in positive and negative directions, respectively.

The other objects in the list are the input arguments passed into \code{h.traits}.
}
\details{
The one-sided subset search maximizes the standard fixed-effect meta-analysis test-statistics over all possible subsets (or over a restricted set of 
subsets if such an option is specified) of studies to detect the best possible association signals. The p-value returned for the maximum test-statistics automatically
accounts for multiple testing penalty due to subset search and can be taken as an evidence of an overall association for the SNP accross the \code{k} studies/traits. 
The one-sided method automatically guarantees identification of studies/traits that have associations in the same direction and thus is useful in applications where
it is desirable to identify SNPs that shows effects in the same direction across multiple traits/studies. The two-sided subset search, applies one-side subset search separately for positively and negatively associated traits for a given SNP and then combines the association
signals from two directions into a single combined chi-square type statistic. The method is sensitive in detecting SNPs that may be associated with different
traits in different directions.

The methods allow for accounting for correlation among studies/subject that might arise due to shared subjects across distinct studies or due to correlation
among related traits in the same study. For application of the method for meta-analysis of case-control studies, the matrices \code{N11}, \code{N10}
 and \code{N00} denote the number subjects that are shared between studies by case-control status. By defintion, the
diagonals of the matrices \code{N11} and \code{N00} contain the number of cases and controls, respectively, in the \code{k} studies. Also, by definition, 
the diagonal of \code{N10} is zero since cases cannot serve as controls and vice versa in the same study. The most common situation
may involve shared controls accross studies, ie non-zero off-diagonal elements of the matrix N00. 

The output standard errors are approximate (based on inverting p-values) and are used for constructing confidence
intervals in \code{\link{h.summary}} and \code{\link{h.forestPlot}}.
}

\references{Samsiddhi Bhattacharjee, Preetha Rajaraman, Kevin B. Jacobs, William A. Wheeler, Beatrice S. Melin, Patricia  Hartge, GliomaScan Consortium, Meredith Yeager, Charles C. Chung, Stephen J. Chanock, Nilanjan Chatterjee. A subset-based  approach improves power and interpretation for combined-analysis of genetic association studies of heterogeneous traits. Am  J Hum Genet, 2012, 90(5):821-35 \cr
}

\seealso{ \code{\link{h.summary}}, \code{\link{h.forestPlot}} }

\examples{
 # Use the example data
 data(ex_trait, package="ASSET")

 # Display the data, and case/control overlap matrices
 data
 N00
 N11
 N10
 
 # Define the input arguments to h.traits
 snps       <- as.vector(data[, "SNP"])
 traits.lab <- paste("Trait_", 1:6, sep="")
 beta.hat   <- as.matrix(data[, paste(traits.lab, ".Beta", sep="")])
 sigma.hat  <- as.matrix(data[, paste(traits.lab, ".SE", sep="")])
 cor        <- list(N11=N11, N00=N00, N10=N10)
 ncase      <- diag(N11)
 ncntl      <- diag(N00)

 # Now let us call h.traits on these summary data. 
 res <- h.traits(snps, traits.lab, beta.hat, sigma.hat, ncase, ncntl, cor=cor, 
                 cor.numr=FALSE, search=NULL, side=2, meta=TRUE, 
                 zmax.args=NULL, meth.pval="DLM")
 
 h.summary(res)

}
 

\keyword{ traits } 

% --- Source file: ex_trait.Rd ---
\name{ex_fast_asset}
\alias{ex_fast_asset}
\alias{betahat}
\alias{SE}
\alias{traits}
\alias{SNP}
\alias{Neff}
\alias{ldscintmat}


%\docType{package}
\title{
  Data for the fast_asset example
}
\description{
 Data for \code{\link{fast_asset}}
}
\details{ The object data contains estimated log odds-ratios and their standard errors
  for 1 snp and 116 traits in \code{betahat} and \code{SE}. The trait names are in \code{traits}
  and the snp name in \code{SNP}. The \code{Neff} vector contains effective sample sizes of the 
  individual traits. The \code{ldscintmat} matrix contains correlation matrix between pairs of 
  traits as estimated using genome-wide LD-score regression.
}
\examples{

 data(ex_fast_asset, package="ASSET")

 # Display the parts of the data objects
 head(betahat)
 head(SE)
 head(traits)
 SNP
 head(Neff)
 ldscintmat[1:6, 1:6]

}
\keyword{fast_asset}
\seealso{h.traits, h.types}

% --- Source file: ex_trait.Rd ---
\name{ex_trait}
\alias{ex_trait}
\alias{data}
\alias{N00}
\alias{N10}
\alias{N11}

%\docType{package}
\title{
  Data for the h.traits example
}
\description{
 Data for \code{\link{h.traits}}
}
\details{ The object data contains estimated log odds-ratios and their standard errors
  for 5 SNPs and 6 traits. The matrices N00, N10, and N11 are the case-control 
  overlap matrices.
}
\examples{

 data(ex_trait, package="ASSET")

 # Display the data, and case/control overlap matrices
 data
 N00
 N11
 N10

}
\keyword{data}
\seealso{h.types, fast_asset}

% --- Source file: man/z.max.Rd ---
\name{z.max}
\alias{z.max}
\title{Z-score Maximization}
\description{
Function to maximize z-scores over subsets of traits or subtypes, with possible restrictions and weights. 
Should not be called directly. See details. 
}

\usage{
z.max(k, snp.vars, side, meta.def, meta.args, th=rep(-1, length(snp.vars)), 
      sub.def=NULL, sub.args=NULL, wt.def=NULL, wt.args=NULL)
}
\arguments{
  \item{k}{Single integer (currently at most 30). The total number of traits or studies or subtypes being analyzed. No default}
  \item{snp.vars}{Vector of integers or string labels for the SNPs being analyzed. No default.}  
  \item{side}{Either 1 or 2. For two-tailed tests (where absolute values of Z-scores are maximzed), \code{side} should be 2. For one-tailed tests, 
  \code{side} should be 1 (positive tail is assumed). Default is 2, ignored when search is 2.}
  \item{meta.def}{Function that calculates z-scores for a given subset, for all the SNPs. Should accept a subset (logical vector of length k) as its
  first argument, followed by a list of SNPs (subset of snp.vars) as its second argument. 
  Should return a named list with at least the name "z", which is the vector of z-scores. The length of the vector should be the same
    length as \code{snp.vars}. 
  Missing z-scores if any are treated as zero, in the maximization. No default.}
  \item{meta.args}{Other arguments to be passed to \code{meta.def} as a named list. For example, this could include an entire data frame containing individual level data as in case of     
  subtype analysis, or sample sizes and correlation matrix in case of meta-analysis of heterogeneous traits. No default.}
  \item{th}{A vector of thresholds for each SNP, beyond which to stop maximization for that SNP. Default is a threshold of -1 for each SNP
  , implying no threshold. This argument is for internal use.}
  \item{sub.def}{A function to restrict subsets, e.g., order restrictions in subtype analysis. Should accept a subset (a logical vector of size k) as
  its first argument and should return TRUE if the subset satisfies restrictions and FALSE otherwise. Default is NULL implying all (2^k - 1) subsets
  are considered in the maximum.}
  \item{sub.args}{Other arguments to be passed to \code{sub.def} as list. Default is NULL (i.e. none).}
  \item{wt.def}{A function that gives weight of one subset with respect to another. Should accept two subsets as first two argumets and return
  a single positive weight. Default NULL. Currently this option is not implemented and the argument is ignored.}
  \item{wt.args}{Other arguments to be passed to \code{wt.def} as a list. Default NULL. Currently ignored.}
}
\value{
   A list with two components. A vector of optimized z-scores (opt.z) and a logical matrix (opt.s) of dimension length(snp.vars) by \code{k}.
   Each row of (opt.s) has indicators of each trait/subtype being included in the best (optimal) subset.
}
\details{
This function loops through all possible (2^k - 1) subsets of (k) studies (or traits or subtypes), skips subsets that are not valid (e.g. 
that do not satisfy order restrictions), and maximizes the z-scores or re-weighted z-scores if weights are specified.  
The function is vectorized to handle blocks of SNPs at a time. Currently weight options are ignored.
This is a helper function that is called internally by \code{\link{h.traits}} and \code{\link{h.types}} 
and should not be called directly. The arguments of this function that have defaults, can be customized using
the argument \code{zmax.args} in \code{\link{h.traits}} and \code{\link{h.types}}.
}

\examples{
  set.seed(123)

  # Define the function to calculate the z-scores
  meta.def <- function(logicalVec, SNP.list, arg.beta, arg.sigma) {

    # Get the snps and subset to use
    beta <- as.matrix(arg.beta[SNP.list, logicalVec])
    se   <- as.matrix(arg.sigma[SNP.list, logicalVec])
    test <- (beta/se)^2
    ret  <- apply(test, 1, max)
    list(z=ret) 
  }

  # Define the function to determine which subsets to consider
  sub.def <- function(logicalVec) {
    # Only allow the cummulative subsets:
    # TRUE FALSE FALSE FALSE ...
    # TRUE TRUE FALSE FALSE ...
    # TRUE TRUE TRUE FALSE ...
    # etc
    sum <- sum(logicalVec)  
    ret <- all(logicalVec[1:sum])
    ret
  }

  # Assume there are 10 subtypes and 3 SNPs
  k        <- 10
  snp.vars <- 1:3
  
  # Generate some data 
  nsnp     <- length(snp.vars)
  beta     <- matrix(-0.5 + runif(k*nsnp), nrow=nsnp)
  sigma    <- matrix(runif(k*nsnp)^2, nrow=nsnp) 

  meta.args <- list(arg.beta=beta, arg.sigma=sigma)
  
  z.max(k, snp.vars, 2, meta.def, meta.args, sub.def=sub.def)
}

% --- Source file: man/p.dlm.Rd ---
\name{p.dlm}
\alias{p.dlm}
\title{Discrete Local Maxima approximate p-value.}
\description{
Function to obtain Discrete Local Maxima based estimates of p-values for z-scores maximized over subsets (of traits or subtypes), 
with possible restrictions and weights. Should not be called directly. See details.
}
\usage{
p.dlm(t.vec, k, search, side, cor.def=NULL, cor.args=NULL, sizes=rep(1, k), 
      sub.def=NULL, sub.args=NULL, wt.def=NULL, wt.args=NULL)
}
\arguments{
  \item{t.vec}{Numeric vector of (positive) points for which to calculate p-values, i.e. general observed Z-max values. No default.}
  \item{k}{Integer (currently less than 30). The number of studies (traits) or subtypes being analyzed. No default.}  
  \item{search}{0, 1 or 2. Search option, with 0 indicating subtype analysis, 1 and 2 denote one-sided and two-sided subset-search. No default.}
  \item{side}{Either 1 or 2. For two-tailed tests (where absolute values of Z-scores are maximized), \code{side} should be 2. For one-tailed tests, 
  \code{side} should be 1 (positive tail assumed). No default. Ignored when search is 2.}
  \item{cor.def}{A function with at least 3 arguments which calculates correlation between its first argument (a subset) and its second argument (subsets such
  as its neighbors). The third argument is the number of traits/subtypes and the function should return a vector of correlations with the neighbors.
 If NULL or a non-function value is specified, internal default 
  functions for the corresponding search option are used.}
  \item{cor.args}{Other arguments to be passed to \code{cor.def}. These can include sample sizes and overlaps of different studies or subtypes and analysis option
  such as case-control or case-complement that affect the correlation structure.
  If \code{cor.def} is NULL, then \code{ncase} and \code{ncntl} must be specified in this list.
  }
  \item{sizes}{Sizes of equivalence classes of traits. By default, no two traits or studies are equivalent. This argument is for internal use.}
  \item{sub.def}{A function to restrict subsets, e.g., order restrictions in subtype analysis. Should accept a subset (a logical vector of size k) as
  its first argument and should return TRUE if the subset satisfies restrictions and FALSE otherwise. Default is NULL implying all (2^k - 1) subsets
  are considered in the maximum.}
  \item{sub.args}{Other arguments to be passed to \code{sub.def} as list. Default is NULL (i.e. none).}
  \item{wt.def}{A function that gives the weight of one subset with respect to another. Should accept two subsets as the first two arguments and return
  a single positive weight. Default NULL. Currently this option is not implemented and the argument is ignored.}
  \item{wt.args}{Other arguments to be passed to \code{wt.def} as a list . Default NULL. Currently ignored.}
  }
\value{
A numeric vector of estimated p-values.
}
\details{ 
The function is vectorized to handle blocks of SNPs at a time. Currently weight options are ignored.
This is a helper function that is called internally by \code{\link{h.traits}} and \code{\link{h.types}} 
and should not be called directly. The arguments of this function that have defaults, can be customized using
the argument \code{pval.args} in \code{\link{h.traits}} and \code{\link{h.types}}.
}

\examples{

  # A function to define the correlations between a subset and its neighbors
  # Returned values should not exceed the value of 1
  cor.def <- function(subset, neighbors, k, ncase, ncntl) {
    n <- ncol(neighbors)
    mat <- matrix(subset, nrow=k, ncol=n, byrow=FALSE)
    cor <- (mat + neighbors)*(1:k)/(k^2)
    cor <- colSums(cor)
    cor <- cor/max(cor)
    dim(cor) <- c(n, 1)

    cor  
  }

  # Subset definition
  sub.def <- function(logicalVec) {
    # Only allow the cummulative subsets:
    # TRUE FALSE FALSE FALSE ...
    # TRUE TRUE FALSE FALSE ...
    # TRUE TRUE TRUE FALSE ...
    # etc
    sum <- sum(logicalVec)  
    ret <- all(logicalVec[1:sum])

    ret
  }

  k     <- 5
  t.vec <- 1:k

  p.dlm(t.vec, k, 1, 2, cor.def=cor.def, sub.def=sub.def,
         cor.args=list(ncase=rep(1000, k), ncntl=rep(1000,k)))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fastASSET.R
\name{create_blocks}
\alias{create_blocks}
\title{Create blocks from correlation matrix}
\usage{
create_blocks(cormat, cor_thr = 0.2)
}
\arguments{
\item{cormat}{A named k by k correlation matrix of z-statistics with row and column names being the names of studies/traits.}

\item{cor_thr}{Threshold of correlation to divide the set of traits into blocks. Z-statistics with correlation less than \code{cor_thr} are treated as uncorrelated.}
}
\value{
A list of character vectors. Each element is a vector of study/trait names that fall into the same correlation block based on \code{cormat}. Studies from different blocks are treated as independent. Studies that are not in the list are treated as independent from other studies.
}
\description{
Partition the set of traits into blocks of correlated traits using hierarchical clustering.
}
\examples{
data("ex_fast_asset", package="ASSET")
block <- create_blocks(ldscintmat)
}
